{
    "$graph": [
        {
            "class": "Workflow",
            "doc": "STARR-seq 01 QC - reads: PE",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "doc": "Adapters file",
                    "type": "File",
                    "id": "#01-qc-pe.cwl/default_adapters_file"
                },
                {
                    "doc": "Input read1 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/input_fastq_read1_files"
                },
                {
                    "doc": "Input read2 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/input_fastq_read2_files"
                },
                {
                    "doc": "Number of threads.",
                    "type": "int",
                    "id": "#01-qc-pe.cwl/nthreads"
                }
            ],
            "steps": [
                {
                    "run": "#diff.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/compare_read_counts_read1/file1",
                        "#01-qc-pe.cwl/compare_read_counts_read1/file2"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/count_raw_reads_read1/output_read_count",
                            "id": "#01-qc-pe.cwl/compare_read_counts_read1/file1"
                        },
                        {
                            "source": "#01-qc-pe.cwl/count_fastqc_reads_read1/output_fastqc_read_count",
                            "id": "#01-qc-pe.cwl/compare_read_counts_read1/file2"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/compare_read_counts_read1/result"
                    ],
                    "id": "#01-qc-pe.cwl/compare_read_counts_read1"
                },
                {
                    "run": "#diff.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/compare_read_counts_read2/file1",
                        "#01-qc-pe.cwl/compare_read_counts_read2/file2"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/count_raw_reads_read2/output_read_count",
                            "id": "#01-qc-pe.cwl/compare_read_counts_read2/file1"
                        },
                        {
                            "source": "#01-qc-pe.cwl/count_fastqc_reads_read2/output_fastqc_read_count",
                            "id": "#01-qc-pe.cwl/compare_read_counts_read2/file2"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/compare_read_counts_read2/result"
                    ],
                    "id": "#01-qc-pe.cwl/compare_read_counts_read2"
                },
                {
                    "run": "#count-fastqc-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/count_fastqc_reads_read1/input_fastqc_data",
                        "#01-qc-pe.cwl/count_fastqc_reads_read1/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read1/basename",
                            "id": "#01-qc-pe.cwl/count_fastqc_reads_read1/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_fastqc_data_read1/output_fastqc_data_file",
                            "id": "#01-qc-pe.cwl/count_fastqc_reads_read1/input_fastqc_data"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/count_fastqc_reads_read1/output_fastqc_read_count"
                    ],
                    "id": "#01-qc-pe.cwl/count_fastqc_reads_read1"
                },
                {
                    "run": "#count-fastqc-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/count_fastqc_reads_read2/input_fastqc_data",
                        "#01-qc-pe.cwl/count_fastqc_reads_read2/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read2/basename",
                            "id": "#01-qc-pe.cwl/count_fastqc_reads_read2/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_fastqc_data_read2/output_fastqc_data_file",
                            "id": "#01-qc-pe.cwl/count_fastqc_reads_read2/input_fastqc_data"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/count_fastqc_reads_read2/output_fastqc_read_count"
                    ],
                    "id": "#01-qc-pe.cwl/count_fastqc_reads_read2"
                },
                {
                    "run": "#count-fastq-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/count_raw_reads_read1/input_fastq_file",
                        "#01-qc-pe.cwl/count_raw_reads_read1/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read1/basename",
                            "id": "#01-qc-pe.cwl/count_raw_reads_read1/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read1_files",
                            "id": "#01-qc-pe.cwl/count_raw_reads_read1/input_fastq_file"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/count_raw_reads_read1/output_read_count"
                    ],
                    "id": "#01-qc-pe.cwl/count_raw_reads_read1"
                },
                {
                    "run": "#count-fastq-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/count_raw_reads_read2/input_fastq_file",
                        "#01-qc-pe.cwl/count_raw_reads_read2/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read2/basename",
                            "id": "#01-qc-pe.cwl/count_raw_reads_read2/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read2_files",
                            "id": "#01-qc-pe.cwl/count_raw_reads_read2/input_fastq_file"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/count_raw_reads_read2/output_read_count"
                    ],
                    "id": "#01-qc-pe.cwl/count_raw_reads_read2"
                },
                {
                    "run": "#basename.cwl",
                    "scatter": "#01-qc-pe.cwl/extract_basename_read1/file_path",
                    "in": [
                        {
                            "valueFrom": "${return true}",
                            "id": "#01-qc-pe.cwl/extract_basename_read1/do_not_escape_sep"
                        },
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read1_files",
                            "valueFrom": "$(self.basename)",
                            "id": "#01-qc-pe.cwl/extract_basename_read1/file_path"
                        },
                        {
                            "valueFrom": "(\\.fastq.gz|\\.fastq)",
                            "id": "#01-qc-pe.cwl/extract_basename_read1/sep"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/extract_basename_read1/basename"
                    ],
                    "id": "#01-qc-pe.cwl/extract_basename_read1"
                },
                {
                    "run": "#basename.cwl",
                    "scatter": "#01-qc-pe.cwl/extract_basename_read2/file_path",
                    "in": [
                        {
                            "valueFrom": "${return true}",
                            "id": "#01-qc-pe.cwl/extract_basename_read2/do_not_escape_sep"
                        },
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read2_files",
                            "valueFrom": "$(self.basename)",
                            "id": "#01-qc-pe.cwl/extract_basename_read2/file_path"
                        },
                        {
                            "valueFrom": "(\\.fastq.gz|\\.fastq)",
                            "id": "#01-qc-pe.cwl/extract_basename_read2/sep"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/extract_basename_read2/basename"
                    ],
                    "id": "#01-qc-pe.cwl/extract_basename_read2"
                },
                {
                    "run": "#extract_fastqc_data.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/extract_fastqc_data_read1/input_qc_report_file",
                        "#01-qc-pe.cwl/extract_fastqc_data_read1/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read1/basename",
                            "id": "#01-qc-pe.cwl/extract_fastqc_data_read1/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/fastqc_read1/output_qc_report_file",
                            "id": "#01-qc-pe.cwl/extract_fastqc_data_read1/input_qc_report_file"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/extract_fastqc_data_read1/output_fastqc_data_file"
                    ],
                    "id": "#01-qc-pe.cwl/extract_fastqc_data_read1"
                },
                {
                    "run": "#extract_fastqc_data.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/extract_fastqc_data_read2/input_qc_report_file",
                        "#01-qc-pe.cwl/extract_fastqc_data_read2/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read2/basename",
                            "id": "#01-qc-pe.cwl/extract_fastqc_data_read2/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/fastqc_read2/output_qc_report_file",
                            "id": "#01-qc-pe.cwl/extract_fastqc_data_read2/input_qc_report_file"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/extract_fastqc_data_read2/output_fastqc_data_file"
                    ],
                    "id": "#01-qc-pe.cwl/extract_fastqc_data_read2"
                },
                {
                    "run": "#fastqc.cwl",
                    "scatter": "#01-qc-pe.cwl/fastqc_read1/input_fastq_file",
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read1_files",
                            "id": "#01-qc-pe.cwl/fastqc_read1/input_fastq_file"
                        },
                        {
                            "source": "#01-qc-pe.cwl/nthreads",
                            "id": "#01-qc-pe.cwl/fastqc_read1/threads"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/fastqc_read1/output_qc_report_file"
                    ],
                    "id": "#01-qc-pe.cwl/fastqc_read1"
                },
                {
                    "run": "#fastqc.cwl",
                    "scatter": "#01-qc-pe.cwl/fastqc_read2/input_fastq_file",
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/input_fastq_read2_files",
                            "id": "#01-qc-pe.cwl/fastqc_read2/input_fastq_file"
                        },
                        {
                            "source": "#01-qc-pe.cwl/nthreads",
                            "id": "#01-qc-pe.cwl/fastqc_read2/threads"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/fastqc_read2/output_qc_report_file"
                    ],
                    "id": "#01-qc-pe.cwl/fastqc_read2"
                },
                {
                    "run": "#overrepresented_sequence_extract.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/input_fastqc_data",
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/default_adapters_file",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/default_adapters_file"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read1/basename",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_fastqc_data_read1/output_fastqc_data_file",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/input_fastqc_data"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/output_custom_adapters"
                    ],
                    "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read1"
                },
                {
                    "run": "#overrepresented_sequence_extract.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/input_fastqc_data",
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#01-qc-pe.cwl/default_adapters_file",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/default_adapters_file"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_basename_read2/basename",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/input_basename"
                        },
                        {
                            "source": "#01-qc-pe.cwl/extract_fastqc_data_read2/output_fastqc_data_file",
                            "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/input_fastqc_data"
                        }
                    ],
                    "out": [
                        "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/output_custom_adapters"
                    ],
                    "id": "#01-qc-pe.cwl/overrepresented_sequence_extract_read2"
                }
            ],
            "id": "#01-qc-pe.cwl",
            "outputs": [
                {
                    "outputSource": "#01-qc-pe.cwl/count_raw_reads_read1/output_read_count",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_count_raw_reads_read1"
                },
                {
                    "outputSource": "#01-qc-pe.cwl/count_raw_reads_read2/output_read_count",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_count_raw_reads_read2"
                },
                {
                    "outputSource": "#01-qc-pe.cwl/overrepresented_sequence_extract_read1/output_custom_adapters",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_custom_adapters_read1"
                },
                {
                    "outputSource": "#01-qc-pe.cwl/overrepresented_sequence_extract_read2/output_custom_adapters",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_custom_adapters_read2"
                },
                {
                    "outputSource": "#01-qc-pe.cwl/compare_read_counts_read1/result",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_diff_counts_read1"
                },
                {
                    "outputSource": "#01-qc-pe.cwl/compare_read_counts_read2/result",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#01-qc-pe.cwl/output_diff_counts_read2"
                },
                {
                    "doc": "FastQC data files for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#01-qc-pe.cwl/extract_fastqc_data_read1/output_fastqc_data_file",
                    "id": "#01-qc-pe.cwl/output_fastqc_data_files_read1"
                },
                {
                    "doc": "FastQC data files for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#01-qc-pe.cwl/extract_fastqc_data_read2/output_fastqc_data_file",
                    "id": "#01-qc-pe.cwl/output_fastqc_data_files_read2"
                },
                {
                    "doc": "FastQC reports in zip format for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#01-qc-pe.cwl/fastqc_read1/output_qc_report_file",
                    "id": "#01-qc-pe.cwl/output_fastqc_report_files_read1"
                },
                {
                    "doc": "FastQC reports in zip format for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#01-qc-pe.cwl/fastqc_read2/output_qc_report_file",
                    "id": "#01-qc-pe.cwl/output_fastqc_report_files_read2"
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": "STARR-seq 02 trimming - reads: PE",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "doc": "Input read 1 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#02-trim-pe.cwl/input_fastq_read1_files"
                },
                {
                    "doc": "Input read 2 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#02-trim-pe.cwl/input_fastq_read2_files"
                },
                {
                    "doc": "Input read 1 adapters files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#02-trim-pe.cwl/input_read1_adapters_files"
                },
                {
                    "doc": "Input read 2 adapters files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#02-trim-pe.cwl/input_read2_adapters_files"
                },
                {
                    "default": 1,
                    "doc": "Number of threads",
                    "type": "int",
                    "id": "#02-trim-pe.cwl/nthreads"
                },
                {
                    "default": "-phred33",
                    "type": "string",
                    "id": "#02-trim-pe.cwl/quality_score"
                },
                {
                    "default": "/usr/share/java/trimmomatic.jar",
                    "doc": "Trimmomatic Java jar file",
                    "type": "string",
                    "id": "#02-trim-pe.cwl/trimmomatic_jar_path"
                },
                {
                    "doc": "JVM arguments should be a quoted, space separated list",
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#02-trim-pe.cwl/trimmomatic_java_opts"
                }
            ],
            "outputs": [
                {
                    "doc": "Trimmed fastq files for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#02-trim-pe.cwl/trimmomatic/output_read1_trimmed_file",
                    "id": "#02-trim-pe.cwl/output_data_fastq_read1_trimmed_files"
                },
                {
                    "doc": "Trimmed fastq files for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#02-trim-pe.cwl/trimmomatic/output_read2_trimmed_paired_file",
                    "id": "#02-trim-pe.cwl/output_data_fastq_read2_trimmed_files"
                },
                {
                    "doc": "Trimmed read counts of paired read 1 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#02-trim-pe.cwl/count_fastq_reads_read1/output_read_count",
                    "id": "#02-trim-pe.cwl/output_trimmed_read1_fastq_read_count"
                },
                {
                    "doc": "Trimmed read counts of paired read 2 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#02-trim-pe.cwl/count_fastq_reads_read2/output_read_count",
                    "id": "#02-trim-pe.cwl/output_trimmed_read2_fastq_read_count"
                }
            ],
            "steps": [
                {
                    "run": "#concat-files.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#02-trim-pe.cwl/concat_adapters/input_file1",
                        "#02-trim-pe.cwl/concat_adapters/input_file2"
                    ],
                    "in": [
                        {
                            "source": "#02-trim-pe.cwl/input_read1_adapters_files",
                            "id": "#02-trim-pe.cwl/concat_adapters/input_file1"
                        },
                        {
                            "source": "#02-trim-pe.cwl/input_read2_adapters_files",
                            "id": "#02-trim-pe.cwl/concat_adapters/input_file2"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/concat_adapters/output_file"
                    ],
                    "id": "#02-trim-pe.cwl/concat_adapters"
                },
                {
                    "run": "#count-fastq-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#02-trim-pe.cwl/count_fastq_reads_read1/input_fastq_file",
                        "#02-trim-pe.cwl/count_fastq_reads_read1/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#02-trim-pe.cwl/extract_basename_read1/basename",
                            "id": "#02-trim-pe.cwl/count_fastq_reads_read1/input_basename"
                        },
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic/output_read1_trimmed_file",
                            "id": "#02-trim-pe.cwl/count_fastq_reads_read1/input_fastq_file"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/count_fastq_reads_read1/output_read_count"
                    ],
                    "id": "#02-trim-pe.cwl/count_fastq_reads_read1"
                },
                {
                    "run": "#count-fastq-reads.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#02-trim-pe.cwl/count_fastq_reads_read2/input_fastq_file",
                        "#02-trim-pe.cwl/count_fastq_reads_read2/input_basename"
                    ],
                    "in": [
                        {
                            "source": "#02-trim-pe.cwl/extract_basename_read2/output_basename",
                            "id": "#02-trim-pe.cwl/count_fastq_reads_read2/input_basename"
                        },
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic/output_read2_trimmed_paired_file",
                            "id": "#02-trim-pe.cwl/count_fastq_reads_read2/input_fastq_file"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/count_fastq_reads_read2/output_read_count"
                    ],
                    "id": "#02-trim-pe.cwl/count_fastq_reads_read2"
                },
                {
                    "run": "#basename.cwl",
                    "scatter": "#02-trim-pe.cwl/extract_basename_read1/file_path",
                    "in": [
                        {
                            "valueFrom": "${return true}",
                            "id": "#02-trim-pe.cwl/extract_basename_read1/do_not_escape_sep"
                        },
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic/output_read1_trimmed_file",
                            "valueFrom": "$(self.basename)",
                            "id": "#02-trim-pe.cwl/extract_basename_read1/file_path"
                        },
                        {
                            "valueFrom": "(\\.fastq.gz|\\.fastq)",
                            "id": "#02-trim-pe.cwl/extract_basename_read1/sep"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/extract_basename_read1/basename"
                    ],
                    "id": "#02-trim-pe.cwl/extract_basename_read1"
                },
                {
                    "run": "#extract-basename.cwl",
                    "scatter": "#02-trim-pe.cwl/extract_basename_read2/input_file",
                    "in": [
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic/output_read2_trimmed_paired_file",
                            "id": "#02-trim-pe.cwl/extract_basename_read2/input_file"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/extract_basename_read2/output_basename"
                    ],
                    "id": "#02-trim-pe.cwl/extract_basename_read2"
                },
                {
                    "run": "#trimmomatic.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#02-trim-pe.cwl/trimmomatic/input_read1_fastq_file",
                        "#02-trim-pe.cwl/trimmomatic/input_read2_fastq_file",
                        "#02-trim-pe.cwl/trimmomatic/input_adapters_file"
                    ],
                    "in": [
                        {
                            "valueFrom": "PE",
                            "id": "#02-trim-pe.cwl/trimmomatic/end_mode"
                        },
                        {
                            "valueFrom": "2:15:10:1:TRUE",
                            "id": "#02-trim-pe.cwl/trimmomatic/illuminaclip"
                        },
                        {
                            "source": "#02-trim-pe.cwl/concat_adapters/output_file",
                            "id": "#02-trim-pe.cwl/trimmomatic/input_adapters_file"
                        },
                        {
                            "source": "#02-trim-pe.cwl/input_fastq_read1_files",
                            "id": "#02-trim-pe.cwl/trimmomatic/input_read1_fastq_file"
                        },
                        {
                            "source": "#02-trim-pe.cwl/input_fastq_read2_files",
                            "id": "#02-trim-pe.cwl/trimmomatic/input_read2_fastq_file"
                        },
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic_java_opts",
                            "id": "#02-trim-pe.cwl/trimmomatic/java_opts"
                        },
                        {
                            "valueFrom": "${return 30}",
                            "id": "#02-trim-pe.cwl/trimmomatic/leading"
                        },
                        {
                            "valueFrom": "${return 15}",
                            "id": "#02-trim-pe.cwl/trimmomatic/minlen"
                        },
                        {
                            "source": "#02-trim-pe.cwl/nthreads",
                            "id": "#02-trim-pe.cwl/trimmomatic/nthreads"
                        },
                        {
                            "valueFrom": "33",
                            "id": "#02-trim-pe.cwl/trimmomatic/phred"
                        },
                        {
                            "valueFrom": "4:20",
                            "id": "#02-trim-pe.cwl/trimmomatic/slidingwindow"
                        },
                        {
                            "valueFrom": "${return 30}",
                            "id": "#02-trim-pe.cwl/trimmomatic/trailing"
                        },
                        {
                            "source": "#02-trim-pe.cwl/trimmomatic_jar_path",
                            "id": "#02-trim-pe.cwl/trimmomatic/trimmomatic_jar_path"
                        }
                    ],
                    "out": [
                        "#02-trim-pe.cwl/trimmomatic/output_read1_trimmed_file",
                        "#02-trim-pe.cwl/trimmomatic/output_read2_trimmed_paired_file"
                    ],
                    "id": "#02-trim-pe.cwl/trimmomatic"
                }
            ],
            "id": "#02-trim-pe.cwl"
        },
        {
            "class": "Workflow",
            "doc": "STARR-seq 03 mapping - reads: PE",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "doc": "Bedfile containing ENCODE consensus blacklist regions to be excluded.",
                    "type": "File",
                    "id": "#03-map-pe.cwl/ENCODE_blacklist_bedfile"
                },
                {
                    "doc": "Bowtie first index files for reference genome (e.g. *1.bt2). The rest of the files should be in the same folder.",
                    "type": "File",
                    "secondaryFiles": [
                        "^^.2.bt2",
                        "^^.3.bt2",
                        "^^.4.bt2",
                        "^^.rev.1.bt2",
                        "^^.rev.2.bt2"
                    ],
                    "id": "#03-map-pe.cwl/genome_ref_first_index_file"
                },
                {
                    "doc": "Genome sizes tab-delimited file (used in samtools)",
                    "type": "File",
                    "id": "#03-map-pe.cwl/genome_sizes_file"
                },
                {
                    "doc": "Input fastq paired-end read 1 files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#03-map-pe.cwl/input_fastq_read1_files"
                },
                {
                    "doc": "Input fastq paired-end read 2 files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#03-map-pe.cwl/input_fastq_read2_files"
                },
                {
                    "default": 1,
                    "type": "int",
                    "id": "#03-map-pe.cwl/nthreads"
                },
                {
                    "default": "/usr/picard/picard.jar",
                    "doc": "Picard Java jar file",
                    "type": "string",
                    "id": "#03-map-pe.cwl/picard_jar_path"
                },
                {
                    "doc": "JVM arguments should be a quoted, space separated list (e.g. \"-Xms128m -Xmx512m\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#03-map-pe.cwl/picard_java_opts"
                },
                {
                    "doc": "Regions bed file used to filter-in reads (used in samtools)",
                    "type": "File",
                    "id": "#03-map-pe.cwl/regions_bed_file"
                }
            ],
            "steps": [
                {
                    "run": "#bedtools-bamtobed.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/bam_to_bepe/bam"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/sort_bams_by_tag_name/sorted_file",
                            "id": "#03-map-pe.cwl/bam_to_bepe/bam"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/bam_to_bepe/bedpe"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/bam_to_bepe/output_bedfile"
                    ],
                    "id": "#03-map-pe.cwl/bam_to_bepe"
                },
                {
                    "run": "#basename.cwl",
                    "scatter": "#03-map-pe.cwl/basename/file_path",
                    "in": [
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/basename/do_not_escape_sep"
                        },
                        {
                            "source": "#03-map-pe.cwl/input_fastq_read1_files",
                            "valueFrom": "$(self.basename)",
                            "id": "#03-map-pe.cwl/basename/file_path"
                        },
                        {
                            "valueFrom": "[\\._]R1",
                            "id": "#03-map-pe.cwl/basename/sep"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/basename/basename"
                    ],
                    "id": "#03-map-pe.cwl/basename"
                },
                {
                    "run": "#bowtie2.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/bowtie2/input_fastq_read1_file",
                        "#03-map-pe.cwl/bowtie2/input_fastq_read2_file",
                        "#03-map-pe.cwl/bowtie2/ungz",
                        "#03-map-pe.cwl/bowtie2/output_filename"
                    ],
                    "in": [
                        {
                            "valueFrom": "${return 2000}",
                            "id": "#03-map-pe.cwl/bowtie2/X"
                        },
                        {
                            "source": "#03-map-pe.cwl/genome_ref_first_index_file",
                            "id": "#03-map-pe.cwl/bowtie2/genome_ref_first_index_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/input_fastq_read1_files",
                            "id": "#03-map-pe.cwl/bowtie2/input_fastq_read1_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/input_fastq_read2_files",
                            "id": "#03-map-pe.cwl/bowtie2/input_fastq_read2_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/bowtie2/nthreads"
                        },
                        {
                            "source": "#03-map-pe.cwl/basename/basename",
                            "id": "#03-map-pe.cwl/bowtie2/output_filename"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/bowtie2/sensitive"
                        },
                        {
                            "source": "#03-map-pe.cwl/basename/basename",
                            "valueFrom": "${return self + \".unmmaped.fastq.gz\"}",
                            "id": "#03-map-pe.cwl/bowtie2/ungz"
                        },
                        {
                            "valueFrom": "${return 2}",
                            "id": "#03-map-pe.cwl/bowtie2/v"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/bowtie2/outfile",
                        "#03-map-pe.cwl/bowtie2/output_bowtie_log",
                        "#03-map-pe.cwl/bowtie2/output_unmapped_reads"
                    ],
                    "id": "#03-map-pe.cwl/bowtie2"
                },
                {
                    "run": "#cut.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/cut_to_bepe/input_file"
                    ],
                    "in": [
                        {
                            "valueFrom": "1,2,6",
                            "id": "#03-map-pe.cwl/cut_to_bepe/columns"
                        },
                        {
                            "source": "#03-map-pe.cwl/bam_to_bepe/output_bedfile",
                            "id": "#03-map-pe.cwl/cut_to_bepe/input_file"
                        },
                        {
                            "valueFrom": ".fragments.txt",
                            "id": "#03-map-pe.cwl/cut_to_bepe/suffix"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/cut_to_bepe/output_file"
                    ],
                    "id": "#03-map-pe.cwl/cut_to_bepe"
                },
                {
                    "run": "#extract-basename.cwl",
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/input_fastq_read1_files",
                            "id": "#03-map-pe.cwl/extract_basename_1/input_file"
                        }
                    ],
                    "scatter": "#03-map-pe.cwl/extract_basename_1/input_file",
                    "out": [
                        "#03-map-pe.cwl/extract_basename_1/output_basename"
                    ],
                    "id": "#03-map-pe.cwl/extract_basename_1"
                },
                {
                    "run": "#remove-extension.cwl",
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/extract_basename_1/output_basename",
                            "id": "#03-map-pe.cwl/extract_basename_2/file_path"
                        }
                    ],
                    "scatter": "#03-map-pe.cwl/extract_basename_2/file_path",
                    "out": [
                        "#03-map-pe.cwl/extract_basename_2/output_path"
                    ],
                    "id": "#03-map-pe.cwl/extract_basename_2"
                },
                {
                    "run": "#samtools-view.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/filter_quality_alignments/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/regions_bed_file",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/L"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/S"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/b"
                        },
                        {
                            "valueFrom": "${return 3}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/f"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/header"
                        },
                        {
                            "source": "#03-map-pe.cwl/bowtie2/outfile",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/input_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/nthreads"
                        },
                        {
                            "valueFrom": "${return 10}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/q"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/filter_quality_alignments/u"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/filter_quality_alignments/outfile"
                    ],
                    "id": "#03-map-pe.cwl/filter_quality_alignments"
                },
                {
                    "run": "#samtools-index.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/index_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/sort_bams/sorted_file",
                            "id": "#03-map-pe.cwl/index_bams/input_file"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/index_bams/indexed_file"
                    ],
                    "id": "#03-map-pe.cwl/index_bams"
                },
                {
                    "run": "#samtools-index.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/index_dedup_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/sort_dedup_bams/sorted_file",
                            "id": "#03-map-pe.cwl/index_dedup_bams/input_file"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/index_dedup_bams/indexed_file"
                    ],
                    "id": "#03-map-pe.cwl/index_dedup_bams"
                },
                {
                    "run": "#samtools-index.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/index_dups_marked_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/mark_duplicates/output_dedup_bam_file",
                            "id": "#03-map-pe.cwl/index_dups_marked_bams/input_file"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/index_dups_marked_bams/indexed_file"
                    ],
                    "id": "#03-map-pe.cwl/index_dups_marked_bams"
                },
                {
                    "run": "#samtools-index.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/index_masked_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/sort_masked_bams/sorted_file",
                            "id": "#03-map-pe.cwl/index_masked_bams/input_file"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/index_masked_bams/indexed_file"
                    ],
                    "id": "#03-map-pe.cwl/index_masked_bams"
                },
                {
                    "run": "#picard-MarkDuplicates.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/mark_duplicates/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/index_masked_bams/indexed_file",
                            "id": "#03-map-pe.cwl/mark_duplicates/input_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/picard_java_opts",
                            "id": "#03-map-pe.cwl/mark_duplicates/java_opts"
                        },
                        {
                            "valueFrom": "$(inputs.input_file.nameroot + \".dups_marked\")",
                            "id": "#03-map-pe.cwl/mark_duplicates/output_filename"
                        },
                        {
                            "valueFrom": "bam",
                            "id": "#03-map-pe.cwl/mark_duplicates/output_suffix"
                        },
                        {
                            "source": "#03-map-pe.cwl/picard_jar_path",
                            "id": "#03-map-pe.cwl/mark_duplicates/picard_jar_path"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/mark_duplicates/output_metrics_file",
                        "#03-map-pe.cwl/mark_duplicates/output_dedup_bam_file"
                    ],
                    "id": "#03-map-pe.cwl/mark_duplicates"
                },
                {
                    "run": "#preseq-c_curve.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/preseq-c-curve/input_sorted_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/index_masked_bams/indexed_file",
                            "id": "#03-map-pe.cwl/preseq-c-curve/input_sorted_file"
                        },
                        {
                            "valueFrom": "$(inputs.input_sorted_file.nameroot + \".preseq_ccurve.txt\")",
                            "id": "#03-map-pe.cwl/preseq-c-curve/output_file_basename"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/preseq-c-curve/pe"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/preseq-c-curve/output_file"
                    ],
                    "id": "#03-map-pe.cwl/preseq-c-curve"
                },
                {
                    "run": "#samtools-view.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/remove_duplicates/input_file"
                    ],
                    "in": [
                        {
                            "valueFrom": "${return 1024}",
                            "id": "#03-map-pe.cwl/remove_duplicates/F"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/remove_duplicates/b"
                        },
                        {
                            "source": "#03-map-pe.cwl/index_dups_marked_bams/indexed_file",
                            "id": "#03-map-pe.cwl/remove_duplicates/input_file"
                        },
                        {
                            "valueFrom": "${return inputs.input_file.basename.replace('dups_marked', 'dedup')}",
                            "id": "#03-map-pe.cwl/remove_duplicates/outfile_name"
                        },
                        {
                            "valueFrom": ".dedup.bam",
                            "id": "#03-map-pe.cwl/remove_duplicates/suffix"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/remove_duplicates/outfile"
                    ],
                    "id": "#03-map-pe.cwl/remove_duplicates"
                },
                {
                    "run": "#bedtools-pairtobed.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/remove_encode_blacklist/abam"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/sort_bams_by_tag_name/sorted_file",
                            "id": "#03-map-pe.cwl/remove_encode_blacklist/abam"
                        },
                        {
                            "source": "#03-map-pe.cwl/ENCODE_blacklist_bedfile",
                            "id": "#03-map-pe.cwl/remove_encode_blacklist/bFile"
                        },
                        {
                            "valueFrom": "neither",
                            "id": "#03-map-pe.cwl/remove_encode_blacklist/type"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/remove_encode_blacklist/filtered"
                    ],
                    "id": "#03-map-pe.cwl/remove_encode_blacklist"
                },
                {
                    "run": "#samtools-sort.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/sort_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/bowtie2/outfile",
                            "id": "#03-map-pe.cwl/sort_bams/input_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/sort_bams/nthreads"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/sort_bams/sorted_file"
                    ],
                    "id": "#03-map-pe.cwl/sort_bams"
                },
                {
                    "run": "#samtools-sort.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/sort_bams_by_tag_name/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/filter_quality_alignments/outfile",
                            "id": "#03-map-pe.cwl/sort_bams_by_tag_name/input_file"
                        },
                        {
                            "valueFrom": "${return true}",
                            "id": "#03-map-pe.cwl/sort_bams_by_tag_name/n"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/sort_bams_by_tag_name/nthreads"
                        },
                        {
                            "valueFrom": ".f3q10.nsorted_bam",
                            "id": "#03-map-pe.cwl/sort_bams_by_tag_name/suffix"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/sort_bams_by_tag_name/sorted_file"
                    ],
                    "id": "#03-map-pe.cwl/sort_bams_by_tag_name"
                },
                {
                    "run": "#samtools-sort.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/sort_dedup_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/remove_duplicates/outfile",
                            "id": "#03-map-pe.cwl/sort_dedup_bams/input_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/sort_dedup_bams/nthreads"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/sort_dedup_bams/sorted_file"
                    ],
                    "id": "#03-map-pe.cwl/sort_dedup_bams"
                },
                {
                    "run": "#samtools-sort.cwl",
                    "scatter": [
                        "#03-map-pe.cwl/sort_masked_bams/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/remove_encode_blacklist/filtered",
                            "id": "#03-map-pe.cwl/sort_masked_bams/input_file"
                        },
                        {
                            "source": "#03-map-pe.cwl/nthreads",
                            "id": "#03-map-pe.cwl/sort_masked_bams/nthreads"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/sort_masked_bams/sorted_file"
                    ],
                    "id": "#03-map-pe.cwl/sort_masked_bams"
                },
                {
                    "run": "#sort.cwl",
                    "scatterMethod": "dotproduct",
                    "scatter": [
                        "#03-map-pe.cwl/sort_to_bepe/input_file"
                    ],
                    "in": [
                        {
                            "source": "#03-map-pe.cwl/cut_to_bepe/output_file",
                            "id": "#03-map-pe.cwl/sort_to_bepe/input_file"
                        },
                        {
                            "valueFrom": "$([\"1,1\", \"2,2g\"])",
                            "id": "#03-map-pe.cwl/sort_to_bepe/k"
                        },
                        {
                            "valueFrom": ".bedpe",
                            "id": "#03-map-pe.cwl/sort_to_bepe/suffix"
                        }
                    ],
                    "out": [
                        "#03-map-pe.cwl/sort_to_bepe/outfile"
                    ],
                    "id": "#03-map-pe.cwl/sort_to_bepe"
                }
            ],
            "outputs": [
                {
                    "doc": "Bowtie log file.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/bowtie2/output_bowtie_log",
                    "id": "#03-map-pe.cwl/output_bowtie_log"
                },
                {
                    "doc": "BAM files with aligned reads.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/index_dups_marked_bams/indexed_file",
                    "id": "#03-map-pe.cwl/output_data_bam_files"
                },
                {
                    "doc": "Dedup BAM files with aligned reads.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/index_dedup_bams/indexed_file",
                    "id": "#03-map-pe.cwl/output_data_dedup_bam_files"
                },
                {
                    "doc": "FASTQ gzipped files with unmapped reads.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/bowtie2/output_unmapped_reads",
                    "id": "#03-map-pe.cwl/output_data_unmapped_fastq_files"
                },
                {
                    "doc": "Picard MarkDuplicates metrics files.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/mark_duplicates/output_metrics_file",
                    "id": "#03-map-pe.cwl/output_picard_mark_duplicates_files"
                },
                {
                    "doc": "Preseq c_curve output files.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/preseq-c-curve/output_file",
                    "id": "#03-map-pe.cwl/output_preseq_c_curve_files"
                },
                {
                    "doc": "Tags/templates coordinates, sorted by chromosome and position (sort -k1,1 -k2,2g).",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#03-map-pe.cwl/sort_to_bepe/outfile",
                    "id": "#03-map-pe.cwl/output_templates_files"
                }
            ],
            "id": "#03-map-pe.cwl"
        },
        {
            "class": "Workflow",
            "doc": "STARR-seq 04 quantification",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "doc": "Bedfile containing ENCODE consensus blacklist regions to be excluded.",
                    "type": "File",
                    "id": "#04-quantification.cwl/ENCODE_blacklist_bedfile"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#04-quantification.cwl/input_bam_files"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "id": "#04-quantification.cwl/input_dedup_bam_files"
                },
                {
                    "default": 1,
                    "type": "int",
                    "id": "#04-quantification.cwl/nthreads"
                }
            ],
            "outputs": [
                {
                    "doc": "Normalized by RPKM bigWig files.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#04-quantification.cwl/bamcoverage-dedup/output_bam_coverage",
                    "id": "#04-quantification.cwl/bw_dedup_norm_files"
                },
                {
                    "doc": "Raw 1bp bigWig files.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#04-quantification.cwl/bamcoverage-dedup-raw/output_bam_coverage",
                    "id": "#04-quantification.cwl/bw_dedup_raw_files"
                },
                {
                    "doc": "Normalized by RPKM bigWig files.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#04-quantification.cwl/bamcoverage-with-dups/output_bam_coverage",
                    "id": "#04-quantification.cwl/bw_with_dups_norm_files"
                }
            ],
            "steps": [
                {
                    "run": "#deeptools-bamcoverage.cwl",
                    "scatter": "#04-quantification.cwl/bamcoverage-dedup/bam",
                    "in": [
                        {
                            "source": "#04-quantification.cwl/input_dedup_bam_files",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/bam"
                        },
                        {
                            "valueFrom": "${return 1}",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/binSize"
                        },
                        {
                            "source": "#04-quantification.cwl/ENCODE_blacklist_bedfile",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/blackListFileName"
                        },
                        {
                            "valueFrom": "$(true)",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/extendReads"
                        },
                        {
                            "valueFrom": "RPKM",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/normalizeUsing"
                        },
                        {
                            "source": "#04-quantification.cwl/nthreads",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/numberOfProcessors"
                        },
                        {
                            "valueFrom": "$(inputs.bam.nameroot.replace(/\\.[^/.]+$/, '.rpkm.bw'))",
                            "id": "#04-quantification.cwl/bamcoverage-dedup/outFileName"
                        }
                    ],
                    "out": [
                        "#04-quantification.cwl/bamcoverage-dedup/output_bam_coverage"
                    ],
                    "id": "#04-quantification.cwl/bamcoverage-dedup"
                },
                {
                    "run": "#deeptools-bamcoverage.cwl",
                    "scatter": "#04-quantification.cwl/bamcoverage-dedup-raw/bam",
                    "in": [
                        {
                            "source": "#04-quantification.cwl/input_dedup_bam_files",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/bam"
                        },
                        {
                            "valueFrom": "${return 1}",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/binSize"
                        },
                        {
                            "source": "#04-quantification.cwl/ENCODE_blacklist_bedfile",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/blackListFileName"
                        },
                        {
                            "valueFrom": "$(true)",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/extendReads"
                        },
                        {
                            "source": "#04-quantification.cwl/nthreads",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/numberOfProcessors"
                        },
                        {
                            "valueFrom": "$(inputs.bam.nameroot.replace(/\\.[^/.]+$/, '.raw.bw'))",
                            "id": "#04-quantification.cwl/bamcoverage-dedup-raw/outFileName"
                        }
                    ],
                    "out": [
                        "#04-quantification.cwl/bamcoverage-dedup-raw/output_bam_coverage"
                    ],
                    "id": "#04-quantification.cwl/bamcoverage-dedup-raw"
                },
                {
                    "run": "#deeptools-bamcoverage.cwl",
                    "scatter": "#04-quantification.cwl/bamcoverage-with-dups/bam",
                    "in": [
                        {
                            "source": "#04-quantification.cwl/input_bam_files",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/bam"
                        },
                        {
                            "valueFrom": "${return 1}",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/binSize"
                        },
                        {
                            "source": "#04-quantification.cwl/ENCODE_blacklist_bedfile",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/blackListFileName"
                        },
                        {
                            "valueFrom": "$(true)",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/extendReads"
                        },
                        {
                            "valueFrom": "RPKM",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/normalizeUsing"
                        },
                        {
                            "source": "#04-quantification.cwl/nthreads",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/numberOfProcessors"
                        },
                        {
                            "valueFrom": "$(inputs.bam.nameroot.replace(/\\.[^/.]+$/, '.rpkm.bw'))",
                            "id": "#04-quantification.cwl/bamcoverage-with-dups/outFileName"
                        }
                    ],
                    "out": [
                        "#04-quantification.cwl/bamcoverage-with-dups/output_bam_coverage"
                    ],
                    "id": "#04-quantification.cwl/bamcoverage-with-dups"
                }
            ],
            "id": "#04-quantification.cwl"
        },
        {
            "class": "Workflow",
            "doc": "STARR-seq pipeline - reads: PE",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "doc": "Bedfile containing ENCODE consensus blacklist regions to be excluded.",
                    "type": "File",
                    "id": "#main/ENCODE_blacklist_bedfile"
                },
                {
                    "doc": "Adapters file",
                    "type": "File",
                    "id": "#main/default_adapters_file"
                },
                {
                    "doc": "\"First index file of Bowtie2 reference genome with extension 1.bt2. \\ (Note: the rest of the index files MUST be in the same folder)\" ",
                    "type": "File",
                    "secondaryFiles": [
                        "^^.2.bt2",
                        "^^.3.bt2",
                        "^^.4.bt2",
                        "^^.rev.1.bt2",
                        "^^.rev.2.bt2"
                    ],
                    "id": "#main/genome_ref_first_index_file"
                },
                {
                    "doc": "Genome sizes tab-delimited file (used in samtools)",
                    "type": "File",
                    "id": "#main/genome_sizes_file"
                },
                {
                    "doc": "Input read1 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/input_fastq_read1_files"
                },
                {
                    "doc": "Input read2 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/input_fastq_read2_files"
                },
                {
                    "doc": "Number of threads - map.",
                    "type": "int",
                    "id": "#main/nthreads_map"
                },
                {
                    "doc": "Number of threads - qc.",
                    "type": "int",
                    "id": "#main/nthreads_qc"
                },
                {
                    "doc": "Number of threads - quantification.",
                    "type": "int",
                    "id": "#main/nthreads_quant"
                },
                {
                    "doc": "Number of threads - trim.",
                    "type": "int",
                    "id": "#main/nthreads_trimm"
                },
                {
                    "doc": "Picard Java jar file",
                    "type": "string",
                    "id": "#main/picard_jar_path"
                },
                {
                    "doc": "JVM arguments should be a quoted, space separated list (e.g. \"-Xms128m -Xmx512m\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/picard_java_opts"
                },
                {
                    "doc": "Regions bed file used to filter-in reads (used in samtools, for example chromosomes of interest)",
                    "type": "File",
                    "id": "#main/regions_bed_file"
                },
                {
                    "doc": "Trimmomatic Java jar file",
                    "type": "string",
                    "id": "#main/trimmomatic_jar_path"
                },
                {
                    "doc": "JVM arguments should be a quoted, space separated list (e.g. \"-Xms128m -Xmx512m\")",
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/trimmomatic_java_opts"
                }
            ],
            "outputs": [
                {
                    "doc": "Bowtie log file with mapping stats",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_bowtie_log",
                    "id": "#main/map_bowtie_log_files"
                },
                {
                    "doc": "Filtered BAM files with duplicates marked (post-processing end point)",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_data_bam_files",
                    "id": "#main/map_dups_marked_bam_files"
                },
                {
                    "doc": "BEDPE files with fragment/template coordinates",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_templates_files",
                    "id": "#main/map_genomic_template_files"
                },
                {
                    "doc": "Summary of duplicates removed with Picard tool MarkDuplicates (for multiple reads aligned to the same positions)",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_picard_mark_duplicates_files",
                    "id": "#main/map_mark_duplicates_files"
                },
                {
                    "doc": "Preseq c_curve output files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_preseq_c_curve_files",
                    "id": "#main/map_preseq_c_curve_files"
                },
                {
                    "doc": "Gzip compressed FASTQ ummaped and unpaired sequences",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/map/output_data_unmapped_fastq_files",
                    "id": "#main/map_unmapped_fastq_files"
                },
                {
                    "outputSource": "#main/qc/output_count_raw_reads_read1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_count_raw_reads_read1"
                },
                {
                    "outputSource": "#main/qc/output_count_raw_reads_read2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_count_raw_reads_read2"
                },
                {
                    "outputSource": "#main/qc/output_custom_adapters_read1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_custom_adapters_read1"
                },
                {
                    "outputSource": "#main/qc/output_custom_adapters_read2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_custom_adapters_read2"
                },
                {
                    "doc": "Trimmed fastq files for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/trim/output_data_fastq_read1_trimmed_files",
                    "id": "#main/output_data_fastq_read1_trimmed_files"
                },
                {
                    "doc": "Trimmed fastq files for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/trim/output_data_fastq_read2_trimmed_files",
                    "id": "#main/output_data_fastq_read2_trimmed_files"
                },
                {
                    "outputSource": "#main/qc/output_diff_counts_read1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_diff_counts_read1"
                },
                {
                    "outputSource": "#main/qc/output_diff_counts_read2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/output_diff_counts_read2"
                },
                {
                    "doc": "FastQC data files for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/qc/output_fastqc_data_files_read1",
                    "id": "#main/output_fastqc_data_files_read1"
                },
                {
                    "doc": "FastQC data files for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/qc/output_fastqc_data_files_read2",
                    "id": "#main/output_fastqc_data_files_read2"
                },
                {
                    "doc": "FastQC reports in zip format for paired read 1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/qc/output_fastqc_report_files_read1",
                    "id": "#main/output_fastqc_report_files_read1"
                },
                {
                    "doc": "FastQC reports in zip format for paired read 2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/qc/output_fastqc_report_files_read2",
                    "id": "#main/output_fastqc_report_files_read2"
                },
                {
                    "doc": "Trimmed read counts of paired read 1 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/trim/output_trimmed_read1_fastq_read_count",
                    "id": "#main/output_trimmed_read1_fastq_read_count"
                },
                {
                    "doc": "Trimmed read counts of paired read 2 fastq files",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/trim/output_trimmed_read2_fastq_read_count",
                    "id": "#main/output_trimmed_read2_fastq_read_count"
                },
                {
                    "doc": "Signal files with RPKM normalization ignoring duplicates.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/quant/bw_dedup_norm_files",
                    "id": "#main/quant_bw_dedup_norm_files"
                },
                {
                    "doc": "Signal files with 1bp raw read pileup ignoring duplicates.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/quant/bw_dedup_raw_files",
                    "id": "#main/quant_bw_dedup_raw_files"
                },
                {
                    "doc": "Signal files with RPKM normalization including duplicates.",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/quant/bw_with_dups_norm_files",
                    "id": "#main/quant_bw_with_dups_norm_files"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/ENCODE_blacklist_bedfile",
                            "id": "#main/map/ENCODE_blacklist_bedfile"
                        },
                        {
                            "source": "#main/genome_ref_first_index_file",
                            "id": "#main/map/genome_ref_first_index_file"
                        },
                        {
                            "source": "#main/genome_sizes_file",
                            "id": "#main/map/genome_sizes_file"
                        },
                        {
                            "source": "#main/trim/output_data_fastq_read1_trimmed_files",
                            "id": "#main/map/input_fastq_read1_files"
                        },
                        {
                            "source": "#main/trim/output_data_fastq_read2_trimmed_files",
                            "id": "#main/map/input_fastq_read2_files"
                        },
                        {
                            "source": "#main/nthreads_map",
                            "id": "#main/map/nthreads"
                        },
                        {
                            "source": "#main/picard_jar_path",
                            "id": "#main/map/picard_jar_path"
                        },
                        {
                            "source": "#main/picard_java_opts",
                            "id": "#main/map/picard_java_opts"
                        },
                        {
                            "source": "#main/regions_bed_file",
                            "id": "#main/map/regions_bed_file"
                        }
                    ],
                    "run": "#03-map-pe.cwl",
                    "out": [
                        "#main/map/output_data_bam_files",
                        "#main/map/output_data_dedup_bam_files",
                        "#main/map/output_picard_mark_duplicates_files",
                        "#main/map/output_data_unmapped_fastq_files",
                        "#main/map/output_bowtie_log",
                        "#main/map/output_preseq_c_curve_files",
                        "#main/map/output_templates_files"
                    ],
                    "id": "#main/map"
                },
                {
                    "in": [
                        {
                            "source": "#main/default_adapters_file",
                            "id": "#main/qc/default_adapters_file"
                        },
                        {
                            "source": "#main/input_fastq_read1_files",
                            "id": "#main/qc/input_fastq_read1_files"
                        },
                        {
                            "source": "#main/input_fastq_read2_files",
                            "id": "#main/qc/input_fastq_read2_files"
                        },
                        {
                            "source": "#main/nthreads_qc",
                            "id": "#main/qc/nthreads"
                        }
                    ],
                    "run": "#01-qc-pe.cwl",
                    "out": [
                        "#main/qc/output_fastqc_report_files_read1",
                        "#main/qc/output_fastqc_data_files_read1",
                        "#main/qc/output_custom_adapters_read1",
                        "#main/qc/output_count_raw_reads_read1",
                        "#main/qc/output_diff_counts_read1",
                        "#main/qc/output_fastqc_report_files_read2",
                        "#main/qc/output_fastqc_data_files_read2",
                        "#main/qc/output_custom_adapters_read2",
                        "#main/qc/output_count_raw_reads_read2",
                        "#main/qc/output_diff_counts_read2"
                    ],
                    "id": "#main/qc"
                },
                {
                    "in": [
                        {
                            "source": "#main/ENCODE_blacklist_bedfile",
                            "id": "#main/quant/ENCODE_blacklist_bedfile"
                        },
                        {
                            "source": "#main/map/output_data_bam_files",
                            "id": "#main/quant/input_bam_files"
                        },
                        {
                            "source": "#main/map/output_data_dedup_bam_files",
                            "id": "#main/quant/input_dedup_bam_files"
                        },
                        {
                            "source": "#main/nthreads_quant",
                            "id": "#main/quant/nthreads"
                        }
                    ],
                    "run": "#04-quantification.cwl",
                    "out": [
                        "#main/quant/bw_dedup_norm_files",
                        "#main/quant/bw_with_dups_norm_files",
                        "#main/quant/bw_dedup_raw_files"
                    ],
                    "id": "#main/quant"
                },
                {
                    "in": [
                        {
                            "source": "#main/input_fastq_read1_files",
                            "id": "#main/trim/input_fastq_read1_files"
                        },
                        {
                            "source": "#main/input_fastq_read2_files",
                            "id": "#main/trim/input_fastq_read2_files"
                        },
                        {
                            "source": "#main/qc/output_custom_adapters_read1",
                            "id": "#main/trim/input_read1_adapters_files"
                        },
                        {
                            "source": "#main/qc/output_custom_adapters_read2",
                            "id": "#main/trim/input_read2_adapters_files"
                        },
                        {
                            "source": "#main/nthreads_trimm",
                            "id": "#main/trim/nthreads"
                        },
                        {
                            "source": "#main/trimmomatic_jar_path",
                            "id": "#main/trim/trimmomatic_jar_path"
                        },
                        {
                            "source": "#main/trimmomatic_java_opts",
                            "id": "#main/trim/trimmomatic_java_opts"
                        }
                    ],
                    "run": "#02-trim-pe.cwl",
                    "out": [
                        "#main/trim/output_data_fastq_read1_trimmed_files",
                        "#main/trim/output_trimmed_read1_fastq_read_count",
                        "#main/trim/output_data_fastq_read2_trimmed_files",
                        "#main/trim/output_trimmed_read2_fastq_read_count"
                    ],
                    "id": "#main/trim"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/bedtools",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-i"
                    },
                    "doc": "Input BAM file to be converted to BED format",
                    "id": "#bedtools-bamtobed.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-bed12"
                    },
                    "doc": "Write \"blocked\" BED format (aka \"BED12\"). Forces -split.\n",
                    "id": "#bedtools-bamtobed.cwl/bed12"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-bedpe"
                    },
                    "doc": "Write BEDPE format.\n- Requires BAM to be grouped or sorted by query.\n",
                    "id": "#bedtools-bamtobed.cwl/bedpe"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-cigar"
                    },
                    "doc": "Add the CIGAR string to the BED entry as a 7th column.\n",
                    "id": "#bedtools-bamtobed.cwl/cigar"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-color"
                    },
                    "doc": "An R,G,B string for the color used with BED12 format.\nDefault is (255,0,0).\n",
                    "id": "#bedtools-bamtobed.cwl/color"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-ed"
                    },
                    "doc": "Use BAM edit distance (NM tag) for BED score.\n- Default for BED is to use mapping quality.\n- Default for BEDPE is to use the minimum of\nthe two mapping qualities for the pair.\n- When -ed is used with -bedpe, the total edit\ndistance from the two mates is reported.\n",
                    "id": "#bedtools-bamtobed.cwl/ed"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-mate1"
                    },
                    "doc": "When writing BEDPE (-bedpe) format, \nalways report mate one as the first BEDPE \"block\".\n",
                    "id": "#bedtools-bamtobed.cwl/mate1"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-split"
                    },
                    "doc": "Report \"split\" BAM alignments as separate BED entries.\nSplits only on N CIGAR operations.\n",
                    "id": "#bedtools-bamtobed.cwl/split"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-splitD"
                    },
                    "doc": "Split alignments based on N and D CIGAR operators.\nForces -split.\n",
                    "id": "#bedtools-bamtobed.cwl/splitD"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-tag"
                    },
                    "doc": "Use other NUMERIC BAM alignment tag for BED score.\n- Default for BED is to use mapping quality.\nDisallowed with BEDPE output.\n",
                    "id": "#bedtools-bamtobed.cwl/tag"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, \"\") + '.bed')"
                    },
                    "id": "#bedtools-bamtobed.cwl/output_bedfile"
                }
            ],
            "baseCommand": [
                "bedtools",
                "bamtobed"
            ],
            "stdout": "$(inputs.bam.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, \"\") + '.bed')",
            "id": "#bedtools-bamtobed.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Tool:    bedtools pairtobed (aka pairToBed)\nVersion: v2.25.0\nSummary: Report overlaps between a BEDPE file and a BED/GFF/VCF file.\n\nUsage:   bedtools pairtobed [OPTIONS] -a <bedpe> -b <bed/gff/vcf>\n\nOptions: \n\t-abam\tThe A input file is in BAM format.  Output will be BAM as well. Replaces -a.\n\t\t- Requires BAM to be grouped or sorted by query.\n\n\t-ubam\tWrite uncompressed BAM output. Default writes compressed BAM.\n\n\t\tis to write output in BAM when using -abam.\n\n\t-bedpe\tWhen using BAM input (-abam), write output as BEDPE. The default\n\t\tis to write output in BAM when using -abam.\n\n\t-ed\tUse BAM total edit distance (NM tag) for BEDPE score.\n\t\t- Default for BEDPE is to use the minimum of\n\t\t  of the two mapping qualities for the pair.\n\t\t- When -ed is used the total edit distance\n\t\t  from the two mates is reported as the score.\n\n\t-f\tMinimum overlap required as fraction of A (e.g. 0.05).\n\t\tDefault is 1E-9 (effectively 1bp).\n\n\t-s\tRequire same strandedness when finding overlaps.\n\t\tDefault is to ignore stand.\n\t\tNot applicable with -type inspan or -type outspan.\n\n\t-S\tRequire different strandedness when finding overlaps.\n\t\tDefault is to ignore stand.\n\t\tNot applicable with -type inspan or -type outspan.\n\n\t-type \tApproach to reporting overlaps between BEDPE and BED.\n\n\t\teither\tReport overlaps if either end of A overlaps B.\n\t\t\t- Default.\n\t\tneither\tReport A if neither end of A overlaps B.\n\t\tboth\tReport overlaps if both ends of A overlap  B.\n\t\txor\tReport overlaps if one and only one end of A overlaps B.\n\t\tnotboth\tReport overlaps if neither end or one and only one \n\t\t\tend of A overlap B.  That is, xor + neither.\n\n\t\tispan\tReport overlaps between [end1, start2] of A and B.\n\t\t\t- Note: If chrom1 <> chrom2, entry is ignored.\n\n\t\tospan\tReport overlaps between [start1, end2] of A and B.\n\t\t\t- Note: If chrom1 <> chrom2, entry is ignored.\n\n\t\tnotispan\tReport A if ispan of A doesn't overlap B.\n\t\t\t\t- Note: If chrom1 <> chrom2, entry is ignored.\n\n\t\tnotospan\tReport A if ospan of A doesn't overlap B.\n\t\t\t\t- Note: If chrom1 <> chrom2, entry is ignored.\n\nRefer to the BEDTools manual for BEDPE format.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/bedtools",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-S"
                    },
                    "doc": "Require different strandedness when finding overlaps.\nDefault is to ignore stand.\nNot applicable with -type inspan or -type outspan.\n",
                    "id": "#bedtools-pairtobed.cwl/S"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-a"
                    },
                    "doc": "<bedpe>",
                    "id": "#bedtools-pairtobed.cwl/aFile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-abam"
                    },
                    "doc": "The A input file is in BAM format.  Output will be BAM as well. Replaces -a. - Requires BAM to be grouped or sorted by query. ",
                    "id": "#bedtools-pairtobed.cwl/abam"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-b"
                    },
                    "doc": "<bed/gff/vcf>",
                    "id": "#bedtools-pairtobed.cwl/bFile"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-bedpe"
                    },
                    "doc": "When using BAM input (-abam), write output as BEDPE. The default\nis to write output in BAM when using -abam.\n",
                    "id": "#bedtools-pairtobed.cwl/bedpe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-ed"
                    },
                    "doc": "Use BAM total edit distance (NM tag) for BEDPE score.\n- Default for BEDPE is to use the minimum of\nof the two mapping qualities for the pair.\n- When -ed is used the total edit distance\nfrom the two mates is reported as the score.\n",
                    "id": "#bedtools-pairtobed.cwl/ed"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "Minimum overlap required as fraction of A (e.g. 0.05).\nDefault is 1E-9 (effectively 1bp).\n",
                    "id": "#bedtools-pairtobed.cwl/f"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Output filename return by this tool\n",
                    "id": "#bedtools-pairtobed.cwl/outfile"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-s"
                    },
                    "doc": "Require same strandedness when finding overlaps.\nDefault is to ignore stand.\nNot applicable with -type inspan or -type outspan.\n",
                    "id": "#bedtools-pairtobed.cwl/s"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-type"
                    },
                    "doc": "\tApproach to reporting overlaps between BEDPE and BED.\neither\tReport overlaps if either end of A overlaps B.\n- Default.\nneither\tReport A if neither end of A overlaps B.\nboth\tReport overlaps if both ends of A overlap  B.\nxor\tReport overlaps if one and only one end of A overlaps B.\nnotboth\tReport overlaps if neither end or one and only one\nend of A overlap B.  That is, xor + neither.\nispan\tReport overlaps between [end1, start2] of A and B.\n- Note: If chrom1 <> chrom2, entry is ignored.\nospan\tReport overlaps between [start1, end2] of A and B.\n- Note: If chrom1 <> chrom2, entry is ignored.\nnotispan\tReport A if ispan of A doesn't overlap B.\n- Note: If chrom1 <> chrom2, entry is ignored.\nnotospan\tReport A if ospan of A doesn't overlap B.\n- Note: If chrom1 <> chrom2, entry is ignored.\nRefer to the BEDTools manual for BEDPE format.\n",
                    "id": "#bedtools-pairtobed.cwl/type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-ubam"
                    },
                    "doc": "Write uncompressed BAM output. Default writes compressed BAM.\n",
                    "id": "#bedtools-pairtobed.cwl/ubam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${return inputs.outfile || inputs.abam.basename.replace(/\\.[^/.]+$/, '') + (inputs.bedpe ? '.bedpe' : '.bam')}\n"
                    },
                    "id": "#bedtools-pairtobed.cwl/filtered"
                }
            ],
            "baseCommand": [
                "bedtools",
                "pairtobed"
            ],
            "stdout": "${return inputs.outfile || inputs.abam.basename.replace(/\\.[^/.]+$/, '') + (inputs.bedpe ? '.bedpe' : '.bam')}\n",
            "id": "#bedtools-pairtobed.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "biocontainers/bowtie2:2.2.8",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-D"
                    },
                    "doc": "<int>           give up extending after <int> failed extends in a row (15) ",
                    "id": "#bowtie2.cwl/D"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-I"
                    },
                    "doc": "--minins <int>  minimum fragment length (0)\n",
                    "id": "#bowtie2.cwl/I"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-L"
                    },
                    "doc": "<int>           length of seed substrings; must be >3, <32 (22)\n",
                    "id": "#bowtie2.cwl/L"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-N"
                    },
                    "doc": "<int>           max # mismatches in seed alignment; can be 0 or 1 (0)\n",
                    "id": "#bowtie2.cwl/N"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-R"
                    },
                    "doc": "<int>           for reads w/ repetitive seeds, try <int> sets of seeds (2) Paired-end: ",
                    "id": "#bowtie2.cwl/R"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-X"
                    },
                    "doc": "--maxins <int>  maximum fragment length (500)\n",
                    "id": "#bowtie2.cwl/X"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-a"
                    },
                    "doc": "--all           report all alignments; very slow, MAPQ not meaningful\nEffort:\n",
                    "id": "#bowtie2.cwl/a"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--al"
                    },
                    "doc": "<path>           write unpaired reads that aligned at least once to <path> ",
                    "id": "#bowtie2.cwl/al"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--al-conc"
                    },
                    "doc": "<path>      write pairs that aligned concordantly at least once to <path> (Note: for --un, --al, --un-conc, or --al-conc, add '-gz' to the option name, e.g. ",
                    "id": "#bowtie2.cwl/al-conc"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "doc": "                <m1>, <m2>, <r> are sequences themselves, not files ",
                    "id": "#bowtie2.cwl/c"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--dpad"
                    },
                    "doc": "<int>       include <int> extra ref chars on sides of DP table (15)\n",
                    "id": "#bowtie2.cwl/dpad"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--end-to-end"
                    },
                    "doc": "      entire read must align; no clipping (on) [default]",
                    "id": "#bowtie2.cwl/end-to-end"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "                query input files are (multi-)FASTA .fa/.mfa ",
                    "id": "#bowtie2.cwl/f"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--fast"
                    },
                    "doc": "      For --end-to-end: -D 10 -R 2 -N 0 -L 22 -i S,0,2.50; For --local: -D 10 -R 2 -N 0 -L 22 -i S,1,1.75",
                    "id": "#bowtie2.cwl/fast"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--fr"
                    },
                    "doc": "--rf/--ff     -1, -2 mates align fw/rev, rev/fw, fw/fw (--fr)\n",
                    "id": "#bowtie2.cwl/fr"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--gbar"
                    },
                    "doc": "<int>       disallow gaps within <int> nucs of read extremes (4)\n",
                    "id": "#bowtie2.cwl/gbar"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^^.2.bt2",
                        "^^.3.bt2",
                        "^^.4.bt2",
                        "^^.rev.1.bt2",
                        "^^.rev.2.bt2"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-x",
                        "valueFrom": "$(self.path.split('.').splice(0,self.path.split('.').length-2).join(\".\"))"
                    },
                    "doc": "First file (extension .1.bt2) of the Bowtie2 index files generated for the reference genome (see http://bowtie-bio.sourceforge.net/bowtie2/manual.shtml#the-bowtie2-build-indexer)",
                    "id": "#bowtie2.cwl/genome_ref_first_index_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "doc": "<func>          interval between seed substrings w/r/t read len (S,1,1.15) ",
                    "id": "#bowtie2.cwl/i"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--ignore-quals"
                    },
                    "doc": "    treat all quality values as 30 on Phred scale (off) ",
                    "id": "#bowtie2.cwl/ignore-quals"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-U"
                    },
                    "doc": "Query input FASTQ file (for single-end samples).",
                    "id": "#bowtie2.cwl/input_fastq_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-1"
                    },
                    "doc": "Query input FASTQ file read 1 (for paired-end samples).",
                    "id": "#bowtie2.cwl/input_fastq_read1_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-2"
                    },
                    "doc": "Query input FASTQ file read 2 (for paired-end samples).",
                    "id": "#bowtie2.cwl/input_fastq_read2_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--int-quals"
                    },
                    "doc": "       qualities encoded as space-delimited integers",
                    "id": "#bowtie2.cwl/int-quals"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-k"
                    },
                    "doc": "<int>           report up to <int> alns per read; MAPQ not meaningful\nOR\n",
                    "id": "#bowtie2.cwl/k"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--local"
                    },
                    "doc": "           local alignment; ends might be soft clipped (off)",
                    "id": "#bowtie2.cwl/local"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--ma"
                    },
                    "doc": "<int>         match bonus (0 for --end-to-end, 2 for --local) \n",
                    "id": "#bowtie2.cwl/ma"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--met"
                    },
                    "doc": "<int>        report internal counters & metrics every <int> secs (1)\n",
                    "id": "#bowtie2.cwl/met"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--met-file"
                    },
                    "doc": "<path>  send metrics to file at <path> (off)\n",
                    "id": "#bowtie2.cwl/met-file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--met-stderr"
                    },
                    "doc": "      send metrics to stderr (off) ",
                    "id": "#bowtie2.cwl/met-stderr"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--mm"
                    },
                    "doc": "              use memory-mapped I/O for index; many bowtie can share",
                    "id": "#bowtie2.cwl/mm"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--mp"
                    },
                    "doc": "<int>         max penalty for mismatch; lower qual = lower penalty (6)\n",
                    "id": "#bowtie2.cwl/mp"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--n-ceil"
                    },
                    "doc": "<func>    func for max # non-A/C/G/Ts permitted in aln (L,0,0.15)\n",
                    "id": "#bowtie2.cwl/n-ceil"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-1mm-upfront"
                    },
                    "doc": "  do not allow 1 mismatch alignments before attempting to scan for the optimal seeded alignments ",
                    "id": "#bowtie2.cwl/no-1mm-upfront"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-contain"
                    },
                    "doc": "      not concordant when one mate alignment contains other ",
                    "id": "#bowtie2.cwl/no-contain"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-discordant"
                    },
                    "doc": "   suppress discordant alignments for paired reads ",
                    "id": "#bowtie2.cwl/no-discordant"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-dovetail"
                    },
                    "doc": "     not concordant when mates extend past each other ",
                    "id": "#bowtie2.cwl/no-dovetail"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-head"
                    },
                    "doc": "         suppress header lines, i.e. lines starting with @ ",
                    "id": "#bowtie2.cwl/no-head"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-mixed"
                    },
                    "doc": "        suppress unpaired alignments for paired reads ",
                    "id": "#bowtie2.cwl/no-mixed"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-overlap"
                    },
                    "doc": "      not concordant when mates overlap at all Output: ",
                    "id": "#bowtie2.cwl/no-overlap"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-sq"
                    },
                    "doc": "           suppress @SQ header lines ",
                    "id": "#bowtie2.cwl/no-sq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--no-unal"
                    },
                    "doc": "         suppress SAM records for unaligned reads ",
                    "id": "#bowtie2.cwl/no-unal"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--nofw"
                    },
                    "doc": "            do not align forward (original) version of read (off) ",
                    "id": "#bowtie2.cwl/nofw"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--non-deterministic"
                    },
                    "doc": "seed rand. gen. arbitrarily instead of using read attributes\n",
                    "id": "#bowtie2.cwl/non-deterministic"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--norc"
                    },
                    "doc": "            do not align reverse-complement version of read (off) ",
                    "id": "#bowtie2.cwl/norc"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--np"
                    },
                    "doc": "<int>         penalty for non-A/C/G/Ts in read/ref (1)\n",
                    "id": "#bowtie2.cwl/np"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--threads"
                    },
                    "doc": "--threads <int> number of alignment threads to launch (1)\n",
                    "id": "#bowtie2.cwl/nthreads"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--omit-sec-seq"
                    },
                    "doc": "    put '*' in SEQ and QUAL fields for secondary alignments. Performance: ",
                    "id": "#bowtie2.cwl/omit-sec-seq"
                },
                {
                    "type": "string",
                    "doc": "name of the output file generated",
                    "id": "#bowtie2.cwl/output_filename"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--phred33"
                    },
                    "doc": "         qualities are Phred+33 (default) ",
                    "id": "#bowtie2.cwl/phred33"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--phred64"
                    },
                    "doc": "         qualities are Phred+64 ",
                    "id": "#bowtie2.cwl/phred64"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-q"
                    },
                    "doc": "                query input files are FASTQ .fq/.fastq (default) ",
                    "id": "#bowtie2.cwl/q"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--qc-filter"
                    },
                    "doc": "       filter out reads that are bad according to QSEQ filter ",
                    "id": "#bowtie2.cwl/qc-filter"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--qseq"
                    },
                    "doc": "            query input files are in Illumina's qseq format ",
                    "id": "#bowtie2.cwl/qseq"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--quiet"
                    },
                    "doc": "           print nothing to stderr except serious errors ",
                    "id": "#bowtie2.cwl/quiet"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-r"
                    },
                    "doc": "                query input files are raw one-sequence-per-line ",
                    "id": "#bowtie2.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--rdg",
                        "shellQuote": false
                    },
                    "doc": "<int>,<int>  read gap open, extend penalties (5,3)\n",
                    "id": "#bowtie2.cwl/rdg"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--reorder"
                    },
                    "doc": "         force SAM output order to match order of input reads ",
                    "id": "#bowtie2.cwl/reorder"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--rfg"
                    },
                    "doc": "<int>,<int>  reference gap open, extend penalties (5,3)\n",
                    "id": "#bowtie2.cwl/rfg"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--rg"
                    },
                    "doc": "<text>        add <text> (\"lab:value\") to @RG line of SAM header.\nNote: @RG line only printed when --rg-id is set.\n",
                    "id": "#bowtie2.cwl/rg"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--rg-id"
                    },
                    "doc": "<text>     set read group id, reflected in @RG line and RG:Z: opt field\n",
                    "id": "#bowtie2.cwl/rg-id"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--score-min"
                    },
                    "doc": "<func> min acceptable alignment score w/r/t read length\n(G,20,8 for local, L,-0.6,-0.6 for end-to-end)\nReporting:\n(default)          look for multiple alignments, report best, with MAPQ\nOR\n",
                    "id": "#bowtie2.cwl/score-min"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--seed"
                    },
                    "doc": "<int>       seed for random number generator (0)\n",
                    "id": "#bowtie2.cwl/seed"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--sensitive"
                    },
                    "doc": "      For --end-to-end: -D 15 -R 2 -N 0 -L 22 -i S,1,1.15; For --local: -D 15 -R 2 -N 0 -L 20 -i S,1,0.75 (default)",
                    "id": "#bowtie2.cwl/sensitive"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--skip"
                    },
                    "doc": "--skip <int>    skip the first <int> reads/pairs in the input (none)\n",
                    "id": "#bowtie2.cwl/skip"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "doc": "--time          print wall-clock time taken by search phases\n",
                    "id": "#bowtie2.cwl/t"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--trim3"
                    },
                    "doc": "--trim3 <int>   trim <int> bases from 3'/right end of reads (0)\n",
                    "id": "#bowtie2.cwl/trim3"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--trim5"
                    },
                    "doc": "--trim5 <int>   trim <int> bases from 5'/left end of reads (0)\n",
                    "id": "#bowtie2.cwl/trim5"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--un"
                    },
                    "doc": "<path>           write unpaired reads that didn't align to <path>\n",
                    "id": "#bowtie2.cwl/un"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--un-conc"
                    },
                    "doc": "<path>      write pairs that didn't align concordantly to <path>\n",
                    "id": "#bowtie2.cwl/un-conc"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--un-gz",
                        "shellQuote": false
                    },
                    "doc": "<path>, to gzip compress output, or add '-bz2' to bzip2 compress output.)\n",
                    "id": "#bowtie2.cwl/ungz"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--upto"
                    },
                    "doc": "--upto <int>    stop after first <int> reads/pairs (no limit)\n",
                    "id": "#bowtie2.cwl/upto"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--version"
                    },
                    "doc": "         print version information and quit ",
                    "id": "#bowtie2.cwl/version"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--very-fast"
                    },
                    "doc": "      For --end-to-end: -D 5 -R 1 -N 0 -L 22 -i S,0,2.50; For --local: -D 5 -R 1 -N 0 -L 25 -i S,1,2.00",
                    "id": "#bowtie2.cwl/very-fast"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--very-sensitive"
                    },
                    "doc": "      For --end-to-end: -D 20 -R 3 -N 0 -L 20 -i S,1,0.50; For --local: -D 20 -R 3 -N 0 -L 20 -i S,1,0.50",
                    "id": "#bowtie2.cwl/very-sensitive"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename + '.sam')"
                    },
                    "id": "#bowtie2.cwl/outfile"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename + '.bowtie2.log')"
                    },
                    "id": "#bowtie2.cwl/output_bowtie_log"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.ungz)"
                    },
                    "id": "#bowtie2.cwl/output_unmapped_reads"
                }
            ],
            "baseCommand": [
                "bowtie2"
            ],
            "stdout": "$(inputs.output_filename + '.sam')",
            "stderr": "$(inputs.output_filename + '.bowtie2.log')",
            "doc": "Bowtie 2 version 2.2.8 by Ben Langmead (langmea@cs.jhu.edu, www.cs.jhu.edu/~langmea)\nUsage:\n  bowtie2 [options]* -x <bt2-idx> {-1 <m1> -2 <m2> | -U <r>} [-S <sam>]\n\n  <bt2-idx>  Index filename prefix (minus trailing .X.bt2).\n             NOTE: Bowtie 1 and Bowtie 2 indexes are not compatible.\n  <m1>       Files with #1 mates, paired with files in <m2>.\n             Could be gzip'ed (extension: .gz) or bzip2'ed (extension: .bz2).\n  <m2>       Files with #2 mates, paired with files in <m1>.\n             Could be gzip'ed (extension: .gz) or bzip2'ed (extension: .bz2).\n  <r>        Files with unpaired reads.\n             Could be gzip'ed (extension: .gz) or bzip2'ed (extension: .bz2).\n  <sam>      File for SAM output (default: stdout)\n\n  <m1>, <m2>, <r> can be comma-separated lists (no whitespace) and can be\n  specified many times.  E.g. '-U file1.fq,file2.fq -U file3.fq'.\n\nOptions (defaults in parentheses):\n\n Input:\n  -q                 query input files are FASTQ .fq/.fastq (default)\n  --qseq             query input files are in Illumina's qseq format\n  -f                 query input files are (multi-)FASTA .fa/.mfa\n  -r                 query input files are raw one-sequence-per-line\n  -c                 <m1>, <m2>, <r> are sequences themselves, not files\n  -s/--skip <int>    skip the first <int> reads/pairs in the input (none)\n  -u/--upto <int>    stop after first <int> reads/pairs (no limit)\n  -5/--trim5 <int>   trim <int> bases from 5'/left end of reads (0)\n  -3/--trim3 <int>   trim <int> bases from 3'/right end of reads (0)\n  --phred33          qualities are Phred+33 (default)\n  --phred64          qualities are Phred+64\n  --int-quals        qualities encoded as space-delimited integers\n\n Presets:                 Same as:\n  For --end-to-end:\n   --very-fast            -D 5 -R 1 -N 0 -L 22 -i S,0,2.50\n   --fast                 -D 10 -R 2 -N 0 -L 22 -i S,0,2.50\n   --sensitive            -D 15 -R 2 -N 0 -L 22 -i S,1,1.15 (default)\n   --very-sensitive       -D 20 -R 3 -N 0 -L 20 -i S,1,0.50\n\n  For --local:\n   --very-fast-local      -D 5 -R 1 -N 0 -L 25 -i S,1,2.00\n   --fast-local           -D 10 -R 2 -N 0 -L 22 -i S,1,1.75\n   --sensitive-local      -D 15 -R 2 -N 0 -L 20 -i S,1,0.75 (default)\n   --very-sensitive-local -D 20 -R 3 -N 0 -L 20 -i S,1,0.50\n\n Alignment:\n  -N <int>           max # mismatches in seed alignment; can be 0 or 1 (0)\n  -L <int>           length of seed substrings; must be >3, <32 (22)\n  -i <func>          interval between seed substrings w/r/t read len (S,1,1.15)\n  --n-ceil <func>    func for max # non-A/C/G/Ts permitted in aln (L,0,0.15)\n  --dpad <int>       include <int> extra ref chars on sides of DP table (15)\n  --gbar <int>       disallow gaps within <int> nucs of read extremes (4)\n  --ignore-quals     treat all quality values as 30 on Phred scale (off)\n  --nofw             do not align forward (original) version of read (off)\n  --norc             do not align reverse-complement version of read (off)\n  --no-1mm-upfront   do not allow 1 mismatch alignments before attempting to\n                     scan for the optimal seeded alignments\n  --end-to-end       entire read must align; no clipping (on)\n   OR\n  --local            local alignment; ends might be soft clipped (off)\n\n Scoring:\n  --ma <int>         match bonus (0 for --end-to-end, 2 for --local)\n  --mp <int>         max penalty for mismatch; lower qual = lower penalty (6)\n  --np <int>         penalty for non-A/C/G/Ts in read/ref (1)\n  --rdg <int>,<int>  read gap open, extend penalties (5,3)\n  --rfg <int>,<int>  reference gap open, extend penalties (5,3)\n  --score-min <func> min acceptable alignment score w/r/t read length\n                     (G,20,8 for local, L,-0.6,-0.6 for end-to-end)\n\n Reporting:\n  (default)          look for multiple alignments, report best, with MAPQ\n   OR\n  -k <int>           report up to <int> alns per read; MAPQ not meaningful\n   OR\n  -a/--all           report all alignments; very slow, MAPQ not meaningful\n\n Effort:\n  -D <int>           give up extending after <int> failed extends in a row (15)\n  -R <int>           for reads w/ repetitive seeds, try <int> sets of seeds (2)\n\n Paired-end:\n  -I/--minins <int>  minimum fragment length (0)\n  -X/--maxins <int>  maximum fragment length (500)\n  --fr/--rf/--ff     -1, -2 mates align fw/rev, rev/fw, fw/fw (--fr)\n  --no-mixed         suppress unpaired alignments for paired reads\n  --no-discordant    suppress discordant alignments for paired reads\n  --no-dovetail      not concordant when mates extend past each other\n  --no-contain       not concordant when one mate alignment contains other\n  --no-overlap       not concordant when mates overlap at all\n\n Output:\n  -t/--time          print wall-clock time taken by search phases\n  --un <path>           write unpaired reads that didn't align to <path>\n  --al <path>           write unpaired reads that aligned at least once to <path>\n  --un-conc <path>      write pairs that didn't align concordantly to <path>\n  --al-conc <path>      write pairs that aligned concordantly at least once to <path>\n  (Note: for --un, --al, --un-conc, or --al-conc, add '-gz' to the option name, e.g.\n  --ungz <path>, to gzip compress output, or add '-bz2' to bzip2 compress output.)\n  --quiet            print nothing to stderr except serious errors\n  --met-file <path>  send metrics to file at <path> (off)\n  --met-stderr       send metrics to stderr (off)\n  --met <int>        report internal counters & metrics every <int> secs (1)\n  --no-unal          suppress SAM records for unaligned reads\n  --no-head          suppress header lines, i.e. lines starting with @\n  --no-sq            suppress @SQ header lines\n  --rg-id <text>     set read group id, reflected in @RG line and RG:Z: opt field\n  --rg <text>        add <text> (\"lab:value\") to @RG line of SAM header.\n                     Note: @RG line only printed when --rg-id is set.\n  --omit-sec-seq     put '*' in SEQ and QUAL fields for secondary alignments.\n\n Performance:\n  -p/--threads <int> number of alignment threads to launch (1)\n  --reorder          force SAM output order to match order of input reads\n  --mm               use memory-mapped I/O for index; many 'bowtie's can share\n\n Other:\n  --qc-filter        filter out reads that are bad according to QSEQ filter\n  --seed <int>       seed for random number generator (0)\n  --non-deterministic seed rand. gen. arbitrarily instead of using read attributes\n  --version          print version information and quit\n",
            "id": "#bowtie2.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/picard",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "BARCODE_TAG=",
                        "separate": false,
                        "position": 5
                    },
                    "doc": "If true do not write duplicates to the output file instead of writing them with appropriate flags set.  (Default false).",
                    "id": "#picard-MarkDuplicates.cwl/barcode_tag"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4,
                        "valueFrom": "$('INPUT=' + self.path)",
                        "shellQuote": false
                    },
                    "doc": "One or more input SAM or BAM files to analyze. Must be coordinate sorted.",
                    "id": "#picard-MarkDuplicates.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "shellQuote": false
                    },
                    "doc": "JVM arguments should be a quoted, space separated list (e.g. \"-Xms128m -Xmx512m\")",
                    "id": "#picard-MarkDuplicates.cwl/java_opts"
                },
                {
                    "type": "string",
                    "default": "dedup_metrics.txt",
                    "doc": "Suffix used to create the metrics output file (Default: dedup_metrics.txt)",
                    "id": "#picard-MarkDuplicates.cwl/metrics_suffix"
                },
                {
                    "type": "string",
                    "doc": "Output filename used as basename",
                    "id": "#picard-MarkDuplicates.cwl/output_filename"
                },
                {
                    "type": "string",
                    "default": "dedup.bam",
                    "doc": "Suffix used to identify the output file (Default: dedup.bam)",
                    "id": "#picard-MarkDuplicates.cwl/output_suffix"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-jar"
                    },
                    "doc": "Path to the picard.jar file",
                    "id": "#picard-MarkDuplicates.cwl/picard_jar_path"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "valueFrom": "$('REMOVE_DUPLICATES=' + self)",
                        "position": 5
                    },
                    "doc": "If true do not write duplicates to the output file instead of writing them with appropriate flags set.  (Default false).",
                    "id": "#picard-MarkDuplicates.cwl/remove_duplicates"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename  + '.' + inputs.output_suffix)"
                    },
                    "id": "#picard-MarkDuplicates.cwl/output_dedup_bam_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename + '.' + inputs.metrics_suffix)"
                    },
                    "id": "#picard-MarkDuplicates.cwl/output_metrics_file"
                }
            ],
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "MarkDuplicates",
                    "position": 3
                },
                {
                    "valueFrom": "$('OUTPUT=' + inputs.output_filename + '.' + inputs.output_suffix)",
                    "position": 5,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$('METRICS_FILE='+inputs.output_filename + '.' + inputs.metrics_suffix)",
                    "position": 5,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$('TMP_DIR='+runtime.tmpdir)",
                    "position": 5,
                    "shellQuote": false
                }
            ],
            "id": "#picard-MarkDuplicates.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Usage: c_curve [OPTIONS] <sorted-bed-file>\n\nOptions:\n  -o, -output   yield output file (default: stdout) \n  -s, -step     step size in extrapolations (default: 1e+06) \n  -v, -verbose  print more information \n  -P, -pe       input is paired end read file \n  -H, -hist     input is a text file containing the observed histogram \n  -V, -vals     input is a text file containing only the observed counts \n  -B, -bam      input is in BAM format \n  -l, -seg_len  maximum segment length when merging paired end bam reads \n                (default: 5000) \n\nHelp options:\n  -?, -help     print this help message \n      -about    print about message",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/preseq:2.0",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-B"
                    },
                    "doc": "-bam      input is in BAM format \n",
                    "id": "#preseq-c_curve.cwl/B"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-H"
                    },
                    "doc": "-hist     input is a text file containing the observed histogram \n",
                    "id": "#preseq-c_curve.cwl/H"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-V"
                    },
                    "doc": "-vals     input is a text file containing only the observed counts \n",
                    "id": "#preseq-c_curve.cwl/V"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Sorted bed or BAM file",
                    "id": "#preseq-c_curve.cwl/input_sorted_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "doc": "-seg_len  maximum segment length when merging paired end bam reads \n(default: 5000)\nHelp options:\n-?, -help     print this help message\n-about    print about message\n",
                    "id": "#preseq-c_curve.cwl/l"
                },
                {
                    "type": "string",
                    "id": "#preseq-c_curve.cwl/output_file_basename"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-P"
                    },
                    "doc": "-pe       input is paired end read file \n",
                    "id": "#preseq-c_curve.cwl/pe"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-s"
                    },
                    "doc": "-step     step size in extrapolations (default: 1e+06) \n",
                    "id": "#preseq-c_curve.cwl/s"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-v"
                    },
                    "doc": "-verbose  print more information \n",
                    "id": "#preseq-c_curve.cwl/v"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file_basename + '.preseq_c_curve.txt')"
                    },
                    "id": "#preseq-c_curve.cwl/output_file"
                }
            ],
            "baseCommand": [
                "preseq",
                "c_curve"
            ],
            "stdout": "$(inputs.output_file_basename + '.preseq_c_curve.txt')",
            "id": "#preseq-c_curve.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "listing": [
                        "$(inputs.input_file)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/samtools:1.3",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "Aligned file to be sorted with samtools",
                    "id": "#samtools-index.cwl/input_file"
                }
            ],
            "outputs": [
                {
                    "doc": "Indexed BAM file",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file.basename)"
                    },
                    "secondaryFiles": ".bai",
                    "id": "#samtools-index.cwl/indexed_file"
                }
            ],
            "baseCommand": [
                "samtools",
                "index"
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.input_file.basename + '.bai')",
                    "position": 2
                }
            ],
            "id": "#samtools-index.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/samtools:1.3",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1000
                    },
                    "doc": "Aligned file to be sorted with samtools",
                    "id": "#samtools-sort.cwl/input_file"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-n"
                    },
                    "doc": "Sort by read name",
                    "id": "#samtools-sort.cwl/n"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-@"
                    },
                    "doc": "Number of threads used in sorting",
                    "id": "#samtools-sort.cwl/nthreads"
                },
                {
                    "type": "string",
                    "default": ".sorted.bam",
                    "doc": "suffix of the transformed SAM/BAM file (including extension, e.g. .filtered.sam)",
                    "id": "#samtools-sort.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, '') + inputs.suffix)"
                    },
                    "doc": "Sorted aligned file",
                    "id": "#samtools-sort.cwl/sorted_file"
                }
            ],
            "baseCommand": [
                "samtools",
                "sort"
            ],
            "stdout": "$(inputs.input_file.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, '') + inputs.suffix)",
            "id": "#samtools-sort.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/samtools:1.3",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-F"
                    },
                    "doc": "only include reads with none of the bits set in INT set in FLAG [0]",
                    "id": "#samtools-view.cwl/F"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-L"
                    },
                    "doc": "FILE  only include reads overlapping this BED FILE [null]",
                    "id": "#samtools-view.cwl/L"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-S"
                    },
                    "doc": "Input format autodetected",
                    "id": "#samtools-view.cwl/S"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-b"
                    },
                    "doc": "output BAM",
                    "id": "#samtools-view.cwl/b"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "only include reads with all bits set in INT set in FLAG [0]",
                    "id": "#samtools-view.cwl/f"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-h"
                    },
                    "doc": "Include header in output",
                    "id": "#samtools-view.cwl/header"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "File to be converted to BAM with samtools",
                    "id": "#samtools-view.cwl/input_file"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-@"
                    },
                    "doc": "Number of threads used",
                    "id": "#samtools-view.cwl/nthreads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Output file name. If not specified, the basename of the input file with the suffix specified in the suffix argument will be used.",
                    "id": "#samtools-view.cwl/outfile_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-q"
                    },
                    "doc": "only include reads with mapping quality >= INT [0]",
                    "id": "#samtools-view.cwl/q"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "suffix of the transformed SAM/BAM file (including extension, e.g. .filtered.sam)",
                    "id": "#samtools-view.cwl/suffix"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-u"
                    },
                    "doc": "uncompressed BAM output (implies -b)",
                    "id": "#samtools-view.cwl/u"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.outfile_name) return inputs.outfile_name;\n  var suffix = inputs.b ? '.bam' : '.sam';\n  suffix = inputs.suffix || suffix;\n  return inputs.input_file.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, '') + suffix\n}\n"
                    },
                    "doc": "Aligned file in SAM or BAM format",
                    "id": "#samtools-view.cwl/outfile"
                }
            ],
            "baseCommand": [
                "samtools",
                "view"
            ],
            "stdout": "${\n   if (inputs.outfile_name) return inputs.outfile_name;\n   var suffix = inputs.b ? '.bam' : '.sam';\n   suffix = inputs.suffix || suffix;\n   return inputs.input_file.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, '') + suffix\n}\n",
            "id": "#samtools-view.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Extracts read count from fastqc_data.txt",
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#count-fastqc-reads.cwl/input_basename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#count-fastqc-reads.cwl/input_fastqc_data"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_basename + '.fastqc-read_count.txt')"
                    },
                    "id": "#count-fastqc-reads.cwl/output_fastqc_read_count"
                }
            ],
            "baseCommand": "count-fastqc_data-reads.sh",
            "stdout": "$(inputs.input_basename + '.fastqc-read_count.txt')",
            "id": "#count-fastqc-reads.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Compares 2 files",
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--brief",
                        "position": 3
                    },
                    "id": "#diff.cwl/brief"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#diff.cwl/file1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#diff.cwl/file2"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "stdout.txt"
                    },
                    "id": "#diff.cwl/result"
                }
            ],
            "baseCommand": "diff",
            "stdout": "stdout.txt",
            "id": "#diff.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Unzips a zipped fastqc report and returns the fastqc_data.txt file. Unzips the file to pipe and uses redirection",
            "hints": [
                {
                    "dockerPull": "dukegcb/fastqc",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "*/fastqc_data.txt",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#extract_fastqc_data.cwl/extract_pattern"
                },
                {
                    "type": "string",
                    "id": "#extract_fastqc_data.cwl/input_basename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#extract_fastqc_data.cwl/input_qc_report_file"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "-p",
                        "position": 1
                    },
                    "id": "#extract_fastqc_data.cwl/pipe"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_basename + '.fastqc_data.txt')"
                    },
                    "id": "#extract_fastqc_data.cwl/output_fastqc_data_file"
                }
            ],
            "baseCommand": "unzip",
            "stdout": "$(inputs.input_basename + '.fastqc_data.txt')",
            "id": "#extract_fastqc_data.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/fastqc",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "fastq",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--format"
                    },
                    "id": "#fastqc.cwl/format"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#fastqc.cwl/input_fastq_file"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--noextract",
                        "position": 2
                    },
                    "id": "#fastqc.cwl/noextract"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--threads"
                    },
                    "id": "#fastqc.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_fastq_file.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.gz$/, '').replace(/\\.[^/.]+$/, '') + \"_fastqc.zip\")"
                    },
                    "id": "#fastqc.cwl/output_qc_report_file"
                }
            ],
            "baseCommand": "fastqc",
            "arguments": [
                {
                    "valueFrom": "$(runtime.tmpdir)",
                    "prefix": "--dir",
                    "position": 5
                },
                {
                    "valueFrom": "$(runtime.outdir)",
                    "prefix": "-o",
                    "position": 5
                }
            ],
            "id": "#fastqc.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "reddylab/overrepresented_sequence_extract:1.0",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Adapters file in fasta format",
                    "id": "#overrepresented_sequence_extract.cwl/default_adapters_file"
                },
                {
                    "type": "string",
                    "doc": "Name of the sample - used as a base name for generating output files",
                    "id": "#overrepresented_sequence_extract.cwl/input_basename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "fastqc_data.txt file from a fastqc report",
                    "id": "#overrepresented_sequence_extract.cwl/input_fastqc_data"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_basename + '.custom_adapters.fasta')"
                    },
                    "id": "#overrepresented_sequence_extract.cwl/output_custom_adapters"
                }
            ],
            "baseCommand": "overrepresented_sequence_extract.py",
            "arguments": [
                {
                    "valueFrom": "$(inputs.input_basename + '.custom_adapters.fasta')",
                    "position": 3
                }
            ],
            "id": "#overrepresented_sequence_extract.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "usage: An example usage is:$ bamCoverage -b reads.bam -o coverage.bw\n\nThis tool takes an alignment of reads or fragments as input (BAM file) and\ngenerates a coverage track (bigWig or bedGraph) as output. The coverage is\ncalculated as the number of reads per bin, where bins are short consecutive\ncounting windows of a defined size. It is possible to extended the length of\nthe reads to better reflect the actual fragment length. *bamCoverage* offers\nnormalization by scaling factor, Reads Per Kilobase per Million mapped reads\n(RPKM), and 1x depth (reads per genome coverage, RPGC).\nRequired arguments:\n  --bam BAM file, -b BAM file\n                        BAM file to process (default: None)\nOutput:\n  --outFileName FILENAME, -o FILENAME\n                        Output file name. (default: None)\n  --outFileFormat {bigwig,bedgraph}, -of {bigwig,bedgraph}\n                        Output file type. Either \"bigwig\" or \"bedgraph\".\n                        (default: bigwig)\nOptional arguments:\n  --help, -h            show this help message and exit\n  --scaleFactor SCALEFACTOR\n                        The smooth length defines a window, larger than the\n                        binSize, to average the number of reads. For example,\n                        if the \u2013binSize is set to 20 and the \u2013smoothLength is\n                        set to 60, then, for each bin, the average of the bin\n                        and its left and right neighbors is considered.\n                        Any value smaller than \u2013binSize will be ignored and\n                        no smoothing will be applied. (default: 1.0)\n  --MNase               Determine nucleosome positions from MNase-seq data.\n                        Only 3 nucleotides at the center of each fragment are\n                        counted. The fragment ends are defined by the two mate\n                        reads. Only fragment lengthsbetween 130 - 200 bp are\n                        considered to avoid dinucleosomes or other\n                        artifacts.*NOTE*: Requires paired-end data. A bin size\n                        of 1 is recommended. (default: False)\n  --filterRNAstrand {forward,reverse}\n                        Selects RNA-seq reads (single-end or paired-end) in\n                        the given strand. (default: None)\n  --version             show program's version number and exit\n  --binSize INT bp, -bs INT bp\n                        Size of the bins, in bases, for the output of the\n                        bigwig/bedgraph file. (default: 50)\n  --region CHR:START:END, -r CHR:START:END\n                        Region of the genome to limit the operation to - this\n                        is useful when testing parameters to reduce the\n                        computing time. The format is chr:start:end, for\n                        example --region chr10 or --region\n                        chr10:456700:891000. (default: None)\n  --blackListFileName BED file, -bl BED file\n                        A BED file containing regions that should be excluded\n                        from all analyses. Currently this works by rejecting\n                        genomic chunks that happen to overlap an entry.\n                        Consequently, for BAM files, if a read partially\n                        overlaps a blacklisted region or a fragment spans over\n                        it, then the read/fragment might still be considered.\n                        (default: None)\n  --numberOfProcessors INT, -p INT\n                        Number of processors to use. Type \"max/2\" to use half\n                        the maximum number of processors or \"max\" to use all\n                        available processors. (default: max/2)\n  --verbose, -v         Set to see processing messages. (default: False)\nRead coverage normalization options:\n  --normalizeTo1x EFFECTIVE GENOME SIZE LENGTH\n                        Report read coverage normalized to 1x sequencing depth\n                        (also known as Reads Per Genomic Content (RPGC)).\n                        Sequencing depth is defined as: (total number of\n                        mapped reads * fragment length) / effective genome\n                        size. The scaling factor used is the inverse of the\n                        sequencing depth computed for the sample to match the\n                        1x coverage. To use this option, the effective genome\n                        size has to be indicated after the option. The\n                        effective genome size is the portion of the genome\n                        that is mappable. Large fractions of the genome are\n                        stretches of NNNN that should be discarded. Also, if\n                        repetitive regions were not included in the mapping of\n                        reads, the effective genome size needs to be adjusted\n                        accordingly. Common values are: mm9: 2,150,570,000;\n                        hg19:2,451,960,000; dm3:121,400,000 and\n                        ce10:93,260,000. See Table 2 of http://www.plosone.org\n                        /article/info:doi/10.1371/journal.pone.0030377 or http\n                        ://www.nature.com/nbt/journal/v27/n1/fig_tab/nbt.1518_\n                        T1.html for several effective genome sizes. (default:\n                        None)\n--ignoreForNormalization IGNOREFORNORMALIZATION [IGNOREFORNORMALIZATION ...]\n                        A list of space-delimited chromosome names containing\n                        those chromosomes that should be excluded for\n                        computing the normalization. This is useful when\n                        considering samples with unequal coverage across\n                        chromosomes, like male samples. An usage examples is\n                        --ignoreForNormalization chrX chrM. (default: None)\n  --skipNonCoveredRegions, --skipNAs\n                        This parameter determines if non-covered regions\n                        (regions without overlapping reads) in a BAM file\n                        should be skipped. The default is to treat those\n                        regions as having a value of zero. The decision to\n                        skip non-covered regions depends on the interpretation\n                        of the data. Non-covered regions may represent, for\n                        example, repetitive regions that should be skipped.\n                        (default: False)\n  --smoothLength INT bp\n                        The smooth length defines a window, larger than the\n                        binSize, to average the number of reads. For example,\n                        if the --binSize is set to 20 and the --smoothLength\n                        is set to 60, then, for each bin, the average of the\n                        bin and its left and right neighbors is considered.\n                        Any value smaller than --binSize will be ignored and\n                        no smoothing will be applied. (default: None)\nRead processing options:\n  --extendReads [INT bp], -e [INT bp]\n                        This parameter allows the extension of reads to\n                        fragment size. If set, each read is extended, without\n                        exception. *NOTE*: This feature is generally NOT\n                        recommended for spliced-read data, such as RNA-seq, as\n                        it would extend reads over skipped regions. *Single-\n                        end*: Requires a user specified value for the final\n                        fragment length. Reads that already exceed this\n                        fragment length will not be extended. *Paired-end*:\n                        Reads with mates are always extended to match the\n                        fragment size defined by the two read mates. Unmated\n                        reads, mate reads that map too far apart (>4x fragment\n                        length) or even map to different chromosomes are\n                        treated like single-end reads. The input of a fragment\n                        length value is optional. If no value is specified, it\n                        is estimated from the data (mean of the fragment size\n                        of all mate reads). (default: False)\n  --ignoreDuplicates    If set, reads that have the same orientation and start\n                        position will be considered only once. If reads are\n                        paired, the mate's position also has to coincide to\n                        ignore a read. (default: False)\n  --minMappingQuality INT\n                        If set, only reads that have a mapping quality score\n                        of at least this are considered. (default: None)\n  --centerReads         By adding this option, reads are centered with respect\n                        to the fragment length. For paired-end data, the read\n                        is centered at the fragment length defined by the two\n                        ends of the fragment. For single-end data, the given\n                        fragment length is used. This option is useful to get\n                        a sharper signal around enriched regions. (default:\n                        False)\n  --samFlagInclude INT  Include reads based on the SAM flag. For example, to\n                        get only reads that are the first mate, use a flag of\n                        64. This is useful to count properly paired reads only\n                        once, as otherwise the second mate will be also\n                        considered for the coverage. (default: None)\n  --samFlagExclude INT  Exclude reads based on the SAM flag. For example, to\n                        get only reads that map to the forward strand, use\n                        --samFlagExclude 16, where 16 is the SAM flag for\n                        reads that map to the reverse strand. (default: None)\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/deeptools:3.0.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--MNase"
                    },
                    "doc": "Determine nucleosome positions from MNase-seq data.\nOnly 3 nucleotides at the center of each fragment are\ncounted. The fragment ends are defined by the two mate\nreads. Only fragment lengthsbetween 130 - 200 bp are\nconsidered to avoid dinucleosomes or other\nartifacts.*NOTE*: Requires paired-end data. A bin size\nof 1 is recommended. (default: False)\n",
                    "id": "#deeptools-bamcoverage.cwl/MNase"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--bam"
                    },
                    "doc": "BAM file to process ",
                    "id": "#deeptools-bamcoverage.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--binSize"
                    },
                    "doc": "INT bp\nSize of the bins, in bases, for the output of the\nbigwig/bedgraph file. (default: 50)\n",
                    "id": "#deeptools-bamcoverage.cwl/binSize"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--blackListFileName"
                    },
                    "doc": "BED file\nA BED file containing regions that should be excluded\nfrom all analyses. Currently this works by rejecting\ngenomic chunks that happen to overlap an entry.\nConsequently, for BAM files, if a read partially\noverlaps a blacklisted region or a fragment spans over\nit, then the read/fragment might still be considered.\n(default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/blackListFileName"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--centerReads"
                    },
                    "doc": "By adding this option, reads are centered with respect\nto the fragment length. For paired-end data, the read\nis centered at the fragment length defined by the two\nends of the fragment. For single-end data, the given\nfragment length is used. This option is useful to get\na sharper signal around enriched regions. (default:\nFalse)\n",
                    "id": "#deeptools-bamcoverage.cwl/centerReads"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--extendReads"
                    },
                    "doc": "INT bp\nThis parameter allows the extension of reads to\nfragment size. If set, each read is extended, without\nexception. *NOTE*: This feature is generally NOT\nrecommended for spliced-read data, such as RNA-seq, as\nit would extend reads over skipped regions. *Single-\nend*: Requires a user specified value for the final\nfragment length. Reads that already exceed this\nfragment length will not be extended. *Paired-end*:\nReads with mates are always extended to match the\nfragment size defined by the two read mates. Unmated\nreads, mate reads that map too far apart (>4x fragment\nlength) or even map to different chromosomes are\ntreated like single-end reads. The input of a fragment\nlength value is optional. If no value is specified, it\nis estimated from the data (mean of the fragment size\nof all mate reads). (default: False)\n",
                    "id": "#deeptools-bamcoverage.cwl/extendReads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--filterRNAstrand"
                    },
                    "doc": "{forward,reverse}\nSelects RNA-seq reads (single-end or paired-end) in\nthe given strand. (default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/filterRNAstrand"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--ignoreDuplicates"
                    },
                    "doc": "If set, reads that have the same orientation and start\nposition will be considered only once. If reads are\npaired, the mate's position also has to coincide to\nignore a read. (default: False)\n",
                    "id": "#deeptools-bamcoverage.cwl/ignoreDuplicates"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--ignoreForNormalization"
                    },
                    "doc": "A list of space-delimited chromosome names containing those chromosomes\nthat should be excluded for computing the normalization. This is useful\nwhen considering samples with unequal coverage across chromosomes, like\nmale samples. An usage examples is \u2013ignoreForNormalization chrX chrM.\n",
                    "id": "#deeptools-bamcoverage.cwl/ignoreForNormalization"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--minMappingQuality"
                    },
                    "doc": "INT\nIf set, only reads that have a mapping quality score\nof at least this are considered. (default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/minMappingQuality"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--normalizeUsing"
                    },
                    "doc": "Possible choices: RPKM, CPM, BPM, RPGC\n\nUse one of the entered methods to normalize the number of reads per bin.\nBy default, no normalization is performed. RPKM = Reads Per Kilobase per\nMillion mapped reads; CPM = Counts Per Million mapped reads, same as\nCPM in RNA-seq; BPM = Bins Per Million mapped reads, same as TPM in\nRNA-seq; RPGC = reads per genomic content (1x normalization);\nMapped reads are considered after blacklist filtering (if applied).\nRPKM (per bin) = number of reads per bin / (number of mapped reads (in millions) * bin length (kb)).\nCPM (per bin) = number of reads per bin / number of mapped reads (in millions).\nBPM (per bin) = number of reads per bin / sum of all reads per bin (in millions).\nRPGC (per bin) = number of reads per bin / scaling factor for 1x average coverage.\nThis scaling factor, in turn, is determined from the sequencing depth:\n(total number of mapped reads * fragment length) / effective genome size.\nThe scaling factor used is the inverse of the sequencing depth\ncomputed for the sample to match the 1x coverage.\nThis option requires \u2013effectiveGenomeSize.\nEach read is considered independently, if you want to only count one\nmate from a pair in paired-end data, then use\nthe \u2013samFlagInclude/\u2013samFlagExclude options.\n",
                    "id": "#deeptools-bamcoverage.cwl/normalizeUsing"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--numberOfProcessors"
                    },
                    "doc": "INT\nNumber of processors to use. Type \"max/2\" to use half\nthe maximum number of processors or \"max\" to use all\navailable processors. (default: max/2)\n",
                    "id": "#deeptools-bamcoverage.cwl/numberOfProcessors"
                },
                {
                    "type": "string",
                    "default": "bigwig",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--outFileFormat"
                    },
                    "doc": "{bigwig,bedgraph}, -of {bigwig,bedgraph}\nOutput file type. Either \"bigwig\" or \"bedgraph\".\n(default: bigwig)\n",
                    "id": "#deeptools-bamcoverage.cwl/outFileFormat"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "FILENAME\nOutput file name. (default: input BAM filename with bigwig [*.bw] or bedgraph [*.bdg] extension.)\n",
                    "id": "#deeptools-bamcoverage.cwl/outFileName"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Suffix used for output file (input BAM filename + suffix)",
                    "id": "#deeptools-bamcoverage.cwl/output_suffix"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--region"
                    },
                    "doc": "CHR:START:END\nRegion of the genome to limit the operation to - this\nis useful when testing parameters to reduce the\ncomputing time. The format is chr:start:end, for\nexample --region chr10 or --region\nchr10:456700:891000. (default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/region"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--samFlagExclude"
                    },
                    "doc": "INT  \nExclude reads based on the SAM flag. For example, to\nget only reads that map to the forward strand, use\n--samFlagExclude 16, where 16 is the SAM flag for\nreads that map to the reverse strand. (default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/samFlagExclude"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--samFlagInclude"
                    },
                    "doc": "INT  \nInclude reads based on the SAM flag. For example, to\nget only reads that are the first mate, use a flag of\n64. This is useful to count properly paired reads only\nonce, as otherwise the second mate will be also\nconsidered for the coverage. (default: None)\n",
                    "id": "#deeptools-bamcoverage.cwl/samFlagInclude"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--scaleFactor"
                    },
                    "doc": "The smooth length defines a window, larger than the\nbinSize, to average the number of reads. For example,\nif the \u2013binSize is set to 20 and the \u2013smoothLength is\nset to 60, then, for each bin, the average of the bin\nand its left and right neighbors is considered.\nAny value smaller than \u2013binSize will be ignored and\nno smoothing will be applied. (default: 1.0)\n",
                    "id": "#deeptools-bamcoverage.cwl/scaleFactor"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--skipNonCoveredRegions"
                    },
                    "doc": "--skipNonCoveredRegions, --skipNAs\nThis parameter determines if non-covered regions\n(regions without overlapping reads) in a BAM file\nshould be skipped. The default is to treat those\nregions as having a value of zero. The decision to\nskip non-covered regions depends on the interpretation\nof the data. Non-covered regions may represent, for\nexample, repetitive regions that should be skipped.\n(default: False)\n",
                    "id": "#deeptools-bamcoverage.cwl/skipNonCoveredRegions"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--smoothLength"
                    },
                    "doc": "INT bp\nThe smooth length defines a window, larger than the\nbinSize, to average the number of reads. For example,\nif the --binSize is set to 20 and the --smoothLength\nis set to 60, then, for each bin, the average of the\nbin and its left and right neighbors is considered.\nAny value smaller than --binSize will be ignored and\nno smoothing will be applied. (default: None)\nRead processing options:\n",
                    "id": "#deeptools-bamcoverage.cwl/smoothLength"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--verbose"
                    },
                    "doc": "--verbose         \nSet to see processing messages. (default: False)\n",
                    "id": "#deeptools-bamcoverage.cwl/verbose"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--version"
                    },
                    "doc": "show program's version number and exit",
                    "id": "#deeptools-bamcoverage.cwl/version"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${ if (inputs.outFileName) return inputs.outFileName; if (inputs.output_suffix) return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + inputs.output_suffix; if (inputs.outFileFormat == \"bedgraph\") return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + \".bdg\"; return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + \".bw\"; }"
                    },
                    "id": "#deeptools-bamcoverage.cwl/output_bam_coverage"
                }
            ],
            "baseCommand": "bamCoverage",
            "arguments": [
                {
                    "valueFrom": "${ if (inputs.outFileName) return inputs.outFileName; if (inputs.output_suffix) return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + inputs.output_suffix; if (inputs.outFileFormat == \"bedgraph\") return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + \".bdg\"; return inputs.bam.path.replace(/^.*[\\\\\\/]/, \"\").replace(/\\.[^/.]+$/, \"\") + \".bw\"; }",
                    "prefix": "--outFileName",
                    "position": 3
                }
            ],
            "id": "#deeptools-bamcoverage.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Trimmomatic is a fast, multithreaded command line tool that can be used to trim and crop\nIllumina (FASTQ) data as well as to remove adapters. These adapters can pose a real problem\ndepending on the library preparation and downstream application.\nThere are two major modes of the program: Paired end mode and Single end mode. The\npaired end mode will maintain correspondence of read pairs and also use the additional\ninformation contained in paired reads to better find adapter or PCR primer fragments\nintroduced by the library preparation process.\nTrimmomatic works with FASTQ files (using phred + 33 or phred + 64 quality scores,\ndepending on the Illumina pipeline used).\n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "dukegcb/trimmomatic",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 101,
                        "prefix": "AVGQUAL:",
                        "separate": false
                    },
                    "doc": "<quality>\nDrop the read if the average quality is below the specified level\n<quality>: Specifies the minimum average quality required to keep a read.\n",
                    "id": "#trimmomatic.cwl/avgqual"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "CROP:",
                        "separate": false
                    },
                    "doc": "<length>\nRemoves bases regardless of quality from the end of the read, so that the read has maximally\nthe specified length after this step has been performed. Steps performed after CROP might of\ncourse further shorten the read.\n<length>: The number of bases to keep, from the start of the read.\n",
                    "id": "#trimmomatic.cwl/crop"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "SE|PE\nSingle End (SE) or Paired End (PE) mode\n",
                    "id": "#trimmomatic.cwl/end_mode"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "HEADCROP:",
                        "separate": false
                    },
                    "doc": "<length>\nRemoves the specified number of bases, regardless of quality, from the beginning of the read.\n<length>: The number of bases to keep, from the start of the read.\n",
                    "id": "#trimmomatic.cwl/headcrop"
                },
                {
                    "type": "string",
                    "doc": "<fastaWithAdaptersEtc>:<seed mismatches>:<palindrome clip threshold>:<simple clip threshold>:<minAdapterLength>:<keepBothReads>\nFind and remove Illumina adapters.\nREQUIRED:\n<fastaWithAdaptersEtc>: specifies the path to a fasta file containing all the adapters, PCR sequences etc.\nThe naming of the various sequences within this file determines how they are used. See below.\n<seedMismatches>: specifies the maximum mismatch count which will still allow a full match to be performed\n<palindromeClipThreshold>: specifies how accurate the match between the two 'adapter ligated' reads must be\nfor PE palindrome read alignment.\n<simpleClipThreshold>: specifies how accurate the match between any adapter etc. sequence must be against a read\nOPTIONAL:\n<minAdapterLength>: In addition to the alignment score, palindrome mode can verify\nthat a minimum length of adapter has been detected. If unspecified, this defaults to 8 bases,\nfor historical reasons. However, since palindrome mode has a very low false positive rate, this\ncan be safely reduced, even down to 1, to allow shorter adapter fragments to be removed.\n<keepBothReads>: After read-though has been detected by palindrome mode, and the\nadapter sequence removed, the reverse read contains the same sequence information as the\nforward read, albeit in reverse complement. For this reason, the default behaviour is to\nentirely drop the reverse read. By specifying \"true\" for this parameter, the reverse read will\nalso be retained, which may be useful e.g. if the downstream tools cannot handle a\ncombination of paired and unpaired reads.\n",
                    "id": "#trimmomatic.cwl/illuminaclip"
                },
                {
                    "type": "File",
                    "doc": "FASTA file containing adapters, PCR sequences, etc. It is used to search for and remove these sequences in the input FASTQ file(s)",
                    "id": "#trimmomatic.cwl/input_adapters_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "FASTQ file for input read (read R1 in Paired End mode)",
                    "id": "#trimmomatic.cwl/input_read1_fastq_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "FASTQ file for read R2 in Paired End mode",
                    "id": "#trimmomatic.cwl/input_read2_fastq_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "shellQuote": false
                    },
                    "doc": "JVM arguments should be a quoted, space separated list (e.g. \"-Xms128m -Xmx512m\")",
                    "id": "#trimmomatic.cwl/java_opts"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 14,
                        "prefix": "LEADING:",
                        "separate": false
                    },
                    "doc": "<quality>\nRemove low quality bases from the beginning. As long as a base has a value below this\nthreshold the base is removed and the next base will be investigated.\n<quality>: Specifies the minimum quality required to keep a base.\n",
                    "id": "#trimmomatic.cwl/leading"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-trimlog"
                    },
                    "doc": "<ouptut log file name>\nSpecifying a trimlog file creates a log of all read trimmings, indicating the following details:\n  the read name\n  the surviving sequence length\n  the location of the first surviving base, aka. the amount trimmed from the start\n  the location of the last surviving base in the original read\n  the amount trimmed from the end\n<ouptut log file name>: filename for the generated output log file.\n",
                    "id": "#trimmomatic.cwl/log_filename"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 15,
                        "prefix": "MAXINFO:",
                        "separate": false
                    },
                    "doc": "<targetLength>:<strictness>\nPerforms an adaptive quality trim, balancing the benefits of retaining longer reads against the\ncosts of retaining bases with errors.\n<targetLength>: This specifies the read length which is likely to allow the\nlocation of the read within the target sequence to be determined.\n<strictness>: This value, which should be set between 0 and 1, specifies the\nbalance between preserving as much read length as possible vs. removal of incorrect\nbases. A low value of this parameter (<0.2) favours longer reads, while a high value\n(>0.8) favours read correctness.\n",
                    "id": "#trimmomatic.cwl/maxinfo"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 100,
                        "prefix": "MINLEN:",
                        "separate": false
                    },
                    "doc": "<length>\nThis module removes reads that fall below the specified minimal length. If required, it should\nnormally be after all other processing steps. Reads removed by this step will be counted and\nincluded in the \"dropped reads\" count presented in the trimmomatic summary.\n<length>:  Specifies the minimum length of reads to be kept\n",
                    "id": "#trimmomatic.cwl/minlen"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-threads"
                    },
                    "doc": "Number of threads",
                    "id": "#trimmomatic.cwl/nthreads"
                },
                {
                    "type": "string",
                    "default": "64",
                    "inputBinding": {
                        "prefix": "-phred",
                        "separate": false,
                        "position": 4
                    },
                    "doc": "\"33\"|\"64\"\n-phred33 (\"33\") or -phred64 (\"64\") specifies the base quality encoding. Default: -phred64\n",
                    "id": "#trimmomatic.cwl/phred"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 15,
                        "prefix": "SLIDINGWINDOW:",
                        "separate": false
                    },
                    "doc": "<windowSize>:<requiredQuality>\nPerform a sliding window trimming, cutting once the average quality within the window falls\nbelow a threshold. By considering multiple bases, a single poor quality base will not cause the\nremoval of high quality data later in the read.\n<windowSize>: specifies the number of bases to average across\n<requiredQuality>: specifies the average quality required\n",
                    "id": "#trimmomatic.cwl/slidingwindow"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "TOPHRED33",
                        "separate": false
                    },
                    "doc": "This (re)encodes the quality part of the FASTQ file to base 33.",
                    "id": "#trimmomatic.cwl/tophred33"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "TOPHRED64",
                        "separate": false
                    },
                    "doc": "This (re)encodes the quality part of the FASTQ file to base 64.",
                    "id": "#trimmomatic.cwl/tophred64"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 14,
                        "prefix": "TRAILING:",
                        "separate": false
                    },
                    "doc": "<quality>\nRemove low quality bases from the end. As long as a base has a value below this threshold\nthe base is removed and the next base (which as trimmomatic is starting from the 3\" prime end\nwould be base preceding the just removed base) will be investigated. This approach can be\nused removing the special illumina \"low quality segment\" regions (which are marked with\nquality score of 2), but we recommend Sliding Window or MaxInfo instead\n<quality>: Specifies the minimum quality required to keep a base.\n",
                    "id": "#trimmomatic.cwl/trailing"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-jar"
                    },
                    "id": "#trimmomatic.cwl/trimmomatic_jar_path"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.log_filename)"
                    },
                    "doc": "Trimmomatic Log file.",
                    "id": "#trimmomatic.cwl/output_log_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_read1_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.trimmed.fastq.gz'))"
                    },
                    "id": "#trimmomatic.cwl/output_read1_trimmed_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.end_mode == \"PE\")\n    return inputs.input_read1_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.unpaired.trimmed.fastq.gz');\n  return null;\n}\n"
                    },
                    "id": "#trimmomatic.cwl/output_read1_trimmed_unpaired_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.end_mode == \"PE\" && inputs.input_read2_fastq_file)\n    return inputs.input_read2_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.trimmed.fastq.gz');\n  return null;\n}\n"
                    },
                    "id": "#trimmomatic.cwl/output_read2_trimmed_paired_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.end_mode == \"PE\" && inputs.input_read2_fastq_file)\n    return inputs.input_read2_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.unpaired.trimmed.fastq.gz');\n  return null;\n}\n"
                    },
                    "id": "#trimmomatic.cwl/output_read2_trimmed_unpaired_file"
                }
            ],
            "baseCommand": "java",
            "arguments": [
                {
                    "valueFrom": "$(\"-Djava.io.tmpdir=\"+runtime.tmpdir)",
                    "shellQuote": false,
                    "position": 1
                },
                {
                    "valueFrom": "$(inputs.input_read1_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.trimmed.fastq.gz'))",
                    "position": 7
                },
                {
                    "valueFrom": "${\n  if (inputs.end_mode == \"PE\" && inputs.input_read2_fastq_file)\n    return inputs.input_read1_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/\\.[^/.]+$/, '') + '.trimmed.unpaired.fastq.gz';\n  return null;\n}\n",
                    "position": 8
                },
                {
                    "valueFrom": "${\n  if (inputs.end_mode == \"PE\" && inputs.input_read2_fastq_file)\n    return inputs.input_read2_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.trimmed.fastq.gz');\n  return null;\n}\n",
                    "position": 9
                },
                {
                    "valueFrom": "${\n  if (inputs.end_mode == \"PE\" && inputs.input_read2_fastq_file)\n    return inputs.input_read2_fastq_file.path.replace(/^.*[\\\\\\/]/, '').replace(/(\\.fq.gz|\\.fastq.gz|\\.[^/.]+)$/, '.unpaired.trimmed.fastq.gz');\n  return null;\n}\n",
                    "position": 10
                },
                {
                    "valueFrom": "$(\"ILLUMINACLIP:\" + inputs.input_adapters_file.path + \":\"+ inputs.illuminaclip)",
                    "position": 11
                }
            ],
            "id": "#trimmomatic.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#basename.cwl/do_not_escape_sep"
                },
                {
                    "type": "string",
                    "id": "#basename.cwl/file_path"
                },
                {
                    "type": "int",
                    "default": 1,
                    "doc": "Number of file extensions to remove",
                    "id": "#basename.cwl/num_ext"
                },
                {
                    "type": "string",
                    "doc": "File extension delimiter",
                    "id": "#basename.cwl/sep"
                }
            ],
            "expression": "${\n  var sep_escaped = !inputs.do_not_escape_sep ? inputs.sep.replace(/[^\\w\\s]/g, \"\\\\$&\") : inputs.sep;\n  var out=inputs.file_path.replace(/^.*[\\\\\\/]/, '');\n  for (var e=0;e<inputs.num_ext; e++){\n    out=out.split(RegExp(\"\\\\b\" + sep_escaped + \"\\\\b\"))[0];\n  }\n  return {\"basename\": out};\n}\n",
            "outputs": [
                {
                    "type": "string",
                    "id": "#basename.cwl/basename"
                }
            ],
            "id": "#basename.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Concat file1 and file2 into output_file.",
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#concat-files.cwl/input_file1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#concat-files.cwl/input_file2"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file1.path.replace(/.*\\/|\\.[^.]*$/g, \"\") + \"_\" + inputs.input_file2.path.replace(/.*\\/|\\.[^.]*$/g, \"\") + \".joined\")"
                    },
                    "id": "#concat-files.cwl/output_file"
                }
            ],
            "baseCommand": "cat",
            "stdout": "$(inputs.input_file1.path.replace(/.*\\/|\\.[^.]*$/g, \"\") + \"_\" + inputs.input_file2.path.replace(/.*\\/|\\.[^.]*$/g, \"\") + \".joined\")",
            "id": "#concat-files.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Counts reads in a fastq file",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#count-fastq-reads.cwl/input_basename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#count-fastq-reads.cwl/input_fastq_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_basename + '.read_count.txt')"
                    },
                    "id": "#count-fastq-reads.cwl/output_read_count"
                }
            ],
            "baseCommand": "count-fastq-reads.sh",
            "stdout": "$(inputs.input_basename + '.read_count.txt')",
            "id": "#count-fastq-reads.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Cut columns from input file.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-f"
                    },
                    "id": "#cut.cwl/columns"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cut.cwl/input_file"
                },
                {
                    "type": "string",
                    "default": ".cut.txt",
                    "id": "#cut.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file.nameroot + inputs.suffix)"
                    },
                    "id": "#cut.cwl/output_file"
                }
            ],
            "baseCommand": "cut",
            "stdout": "$(inputs.input_file.nameroot + inputs.suffix)",
            "id": "#cut.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Extracts the base name of a file",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#extract-basename.cwl/input_file"
                }
            ],
            "outputs": [
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "$(inputs.input_file.path.substr(inputs.input_file.path.lastIndexOf('/') + 1, inputs.input_file.path.lastIndexOf('.') - (inputs.input_file.path.lastIndexOf('/') + 1)))"
                    },
                    "id": "#extract-basename.cwl/output_basename"
                }
            ],
            "baseCommand": "echo",
            "id": "#extract-basename.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Extracts the base name of a file",
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#remove-extension.cwl/file_path"
                }
            ],
            "outputs": [
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "$(inputs.file_path.replace(/\\.[^/.]+$/, \"\"))"
                    },
                    "id": "#remove-extension.cwl/output_path"
                }
            ],
            "baseCommand": "echo",
            "id": "#remove-extension.cwl"
        },
        {
            "class": "CommandLineTool",
            "doc": "Usage: sort [OPTION]... [FILE]...\nWrite sorted concatenation of all FILE(s) to standard output.\n\n\nMandatory arguments to long options are mandatory for short options too.\nOrdering options:\n\n\n\n  -b, --ignore-leading-blanks  ignore leading blanks\n\n  -d, --dictionary-order      consider only blanks and alphanumeric characters\n\n  -f, --ignore-case           fold lower case to upper case characters\n\n  -g, --general-numeric-sort  compare according to general numerical value\n\n  -i, --ignore-nonprinting    consider only printable characters\n\n  -M, --month-sort            compare (unknown) < `JAN' < ... < `DEC'\n\n  -n, --numeric-sort          compare according to string numerical value\n\n  -r, --reverse               reverse the result of comparisons\n\n\n\nOther options:\n\n\n\n  -c, --check               check whether input is sorted; do not sort\n\n  -k, --key=POS1[,POS2]     start a key at POS1, end it at POS2 (origin 1)\n\n  -m, --merge               merge already sorted files; do not sort\n\n  -o, --output=FILE         write result to FILE instead of standard output\n\n  -s, --stable              stabilize sort by disabling last-resort comparison\n\n  -S, --buffer-size=SIZE    use SIZE for main memory buffer\n\n  -t, --field-separator=SEP  use SEP instead of non-blank to blank transition\n\n  -T, --temporary-directory=DIR  use DIR for temporaries, not $TMPDIR or /tmp;\n\n                              multiple options specify multiple directories\n\n  -u, --unique              with -c, check for strict ordering;\n\n                              without -c, output only the first of an equal\nrun\n\n  -z, --zero-terminated     end lines with 0 byte, not newline\n\n      --help     display this help and exit\n\n      --version  output version information and exit\n\n\n\nPOS is F[.C][OPTS], where F is the field number and C the character position\nin the field.  OPTS is one or more single-letter ordering options, which\noverride global ordering options for that key.  If no key is given, use the\nentire line as the key.\n\n\nSIZE may be followed by the following multiplicative suffixes:\n% 1% of memory, b 1, K 1024 (default), and so on for M, G, T, P, E, Z, Y.\n\n\nWith no FILE, or when FILE is -, read standard input.\n\n\n*** WARNING ***\nThe locale specified by the environment affects sort order.\nSet LC_ALL=C to get the traditional sort order that uses\nnative byte values.\n\n\nReport bugs to <bug-coreutils@gnu.org>.",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "reddylab/workflow-utils:ggr",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-M"
                    },
                    "doc": "--month-sort            compare (unknown) < `JAN' < ... < `DEC'\n",
                    "id": "#sort.cwl/M"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-S"
                    },
                    "doc": "--buffer-size=SIZE    use SIZE for main memory buffer\n",
                    "id": "#sort.cwl/S"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-b"
                    },
                    "doc": "--ignore-leading-blanks  ignore leading blanks\n",
                    "id": "#sort.cwl/b"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "doc": "--check               check whether input is sorted; do not sort\n",
                    "id": "#sort.cwl/c"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-d"
                    },
                    "doc": "--dictionary-order      consider only blanks and alphanumeric characters\n",
                    "id": "#sort.cwl/d"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "--ignore-case           fold lower case to upper case characters\n",
                    "id": "#sort.cwl/f"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-g"
                    },
                    "doc": "--general-numeric-sort  compare according to general numerical value\n",
                    "id": "#sort.cwl/g"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "doc": "--ignore-nonprinting    consider only printable characters\n",
                    "id": "#sort.cwl/i"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#sort.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 1,
                        "itemSeparator": " -k ",
                        "prefix": "-k",
                        "shellQuote": false
                    },
                    "doc": "--key=POS1[,POS2]     start a key at POS1, end it at POS2 (origin 1)\n",
                    "id": "#sort.cwl/k"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-m"
                    },
                    "doc": "--merge               merge already sorted files; do not sort\n",
                    "id": "#sort.cwl/m"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-n"
                    },
                    "doc": "--numeric-sort          compare according to string numerical value\n",
                    "id": "#sort.cwl/n"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-r"
                    },
                    "doc": "--reverse               reverse the result of comparisons\nOther options:\n",
                    "id": "#sort.cwl/r"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-s"
                    },
                    "doc": "--stable              stabilize sort by disabling last-resort comparison\n",
                    "id": "#sort.cwl/s"
                },
                {
                    "type": "string",
                    "default": ".sorted.txt",
                    "id": "#sort.cwl/suffix"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "doc": "--field-separator=SEP  use SEP instead of non-blank to blank transition\n",
                    "id": "#sort.cwl/t"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-u"
                    },
                    "doc": "--unique              with -c, check for strict ordering;\nwithout -c, output only the first of an equal run\n",
                    "id": "#sort.cwl/u"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-z"
                    },
                    "doc": "--zero-terminated     end lines with 0 byte, not newline\n",
                    "id": "#sort.cwl/z"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file.nameroot + inputs.suffix)"
                    },
                    "id": "#sort.cwl/outfile"
                }
            ],
            "baseCommand": [
                "sort"
            ],
            "stdout": "$(inputs.input_file.nameroot + inputs.suffix)",
            "arguments": [
                {
                    "valueFrom": "$(runtime.tmpdir)",
                    "position": 1,
                    "prefix": "--temporary-directory"
                }
            ],
            "id": "#sort.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
